#include "headers.h"
#include <cmath>
#include <cstdlib>
#include <iostream>
#include <set>
#include <queue>
#define REP(i,n) for(int i=0; i<(int)(n); ++i)
#define FOR(i,a,b) for(int i=(int)(a); i<=(int)(b); ++i)
#define FORD(i,a,b) for(int i=(int)(a); i>=(int)(b); --i)
#define SIZE(x) ((int)(x.size()))
#define SQR(x) ((x)*(x))
#define dist(ax, ay, bx, by) (abs(ax - bx) + abs(ay - by))
#define INF 987654321

typedef struct {
  int x, y;
} POINT;

bool operator< (const POINT &a, const POINT &b) {
	if (a.x == b.x) return (a.y < b.y);
	return a.x < b.x;
}


int RIADKY, STLPCE;

char nick[] = "ZappBrannigan";

int mapa[MAX_ROZMER][MAX_ROZMER];

set<POINT> packs;

int magsize[5];

int destx, desty;
bool wasdest = false;

void Initialize(){ //{{{
	srand(time(NULL));
	REP(r,RIADKY)
		REP(c,STLPCE)
			mapa[r][c] = UNKNOWN;

	magsize[0] = PISTOLZASOBNIK;
	magsize[1] = BROKZASOBNIK;
	magsize[2] = BAZOOKAZASOBNIK;
	magsize[3] = KATUSAZASOBNIK;
	magsize[4] = UZIZASOBNIK;

}//}}}

void ShowMap(){ //{{{
	REP(r,RIADKY){
		REP(c,STLPCE)
			cout << ((mapa[r][c] == UNKNOWN) ? ('?') : ((mapa[r][c] == STENA) ? 'X' : '.'));
		cout << endl;
	}
	cout << endl;
}//}}}

int Rotor(int rotation, int sx, int sy, int dx, int dy, int &rot) { // {{{
	double best = -2.0, tmp;
	int vx, vy, bi, change;
	vx = dx - sx;
	vy = dy - sy;

	REP(i, 16) {
		tmp=(vx*smerx[i] + vy*smery[i])/sqrt(SQR(vx) + SQR(vy))/sqrt(SQR(smerx[i]) + SQR(smery[i]));
		if(tmp >= best) {
			best = tmp;
			bi = i;
		}
	}

	if (rotation != bi){
		int ccw = (bi - rotation + 16) % 16;
		int cw = (rotation - bi + 16) % 16;
		change = min(ccw, cw);
		if (ccw <= cw)
			rot = min(ccw, 2);
		else rot = max(-cw, -2);
	} else {
		change = 0;
		rot = 0;
	}

	return change;
} // }}}

Action Step(const GameData &data){
	Action ret;
	ret.weaponaction = NOTHING;
	ret.rotate = 0;
	ret.mx = ret.my = 0;

	// map update {{{	
	REP(r,RIADKY)
		REP(c,STLPCE)
			if((mapa[r][c] == UNKNOWN) && (data.mapa[r][c] != UNKNOWN))
				mapa[r][c] = data.mapa[r][c];
	//}}}

//	ShowMap();

	bool menace = false;
	int mx = INF, my = INF;

	bool isPack = false;
	int px = INF, py = INF;

	// recognize objects {{{
	REP(i,data.nObjects)
		switch (data.objects[i].type) {
			case OBJECT_PLAYER:
				menace = true;
				if (dist(data.objects[i].x, data.objects[i].y, data.x, data.y) < dist(mx, my, data.x, data.y)) {
					mx = data.objects[i].x;
					my = data.objects[i].y;
				}
			break;

			case OBJECT_AMMO:
			case OBJECT_AMMO+1:
			case OBJECT_AMMO+2:
			case OBJECT_AMMO+3:
			case OBJECT_AMMO+4:
				packs.insert((POINT) {data.objects[i].x, data.objects[i].y});
				isPack = true;
				if (dist(data.objects[i].x, data.objects[i].y, data.x, data.y) < dist(px, py, data.x, data.y) + 2-rand()%5) {
					px = data.objects[i].x;
					py = data.objects[i].y;
				}
			break;
		}
	//}}}

	bool harmless = false;

	// weapon check {{{
	if (data.zasobnik == 0) {
		harmless = true;

		if (data.zbytok != 0) {
			ret.weaponaction = RELOAD;
			harmless = false;
		} else {
			REP(i, 5)
				if (data.zasobniky[i] != 0) {
					ret.weaponaction = CHANGE_WEAPON + i;
					harmless = false;
				}

			if (harmless) {
				REP(i, 5)
					if (data.zbytky[i] != 0) {
						ret.weaponaction = CHANGE_WEAPON + i;
						harmless = false;
					}				
			}
		}
	}
	// }}}

	int dx, dy;
	bool isDest = false;

	if (menace && !harmless) { // bite my shiny metal ass {{{
		int change = Rotor(data.rotate, data.x, data.y, mx, my, ret.rotate);
		if ((change <= 1 || ((change <= 2) && (data.curweapon != KATUSA) && (data.curweapon != BAZOOKA))) && (data.blocktime == 0) && (data.zasobnik != 0))
			ret.weaponaction = SHOT;
		else {
			isDest = true;
			dx = mx;
			dy = my;
		}
		
		if (data.blocktime != 0) {
			if ((data.curweapon == PISTOL) && (data.zasobniky[UZI] + data.zbytky[UZI] > 0))
				ret.weaponaction = CHANGE_WEAPON + UZI;
	
			if ((data.curweapon == BAZOOKA) && (data.zasobniky[KATUSA] + data.zbytky[KATUSA] > 0))
				ret.weaponaction = CHANGE_WEAPON + KATUSA;
		}

		// }}}
	} else { // unarmed behavior {{{
		if (isPack) {
			if (harmless || (rand()%4 == 0)) {
				dx = px;
				dy = py;
				isDest = true;
			}
		} else if (harmless) {
			if(wasdest && (rand()%2 == 0)) {
				isDest = true;
				dx = destx;
				dy = desty;
			} else {
				for(set<POINT>::iterator i = packs.begin(); i != packs.end(); ++i)
					if(data.mapa[i->y][i->x] == UNKNOWN)
						if(!isDest || (dist(i->x, i->y, data.x, data.y) < dist(dx, dy, data.x, data.y))) {
							isDest = true;
							dx = i->x;
							dy = i->y;
						}
			}
		}

 		if (!isDest) {
			isPack = false;
			if (wasdest && (rand()%8 != 0)) {
				isDest = true;
				dx = destx;
				dy = desty;
			} else {
				int rx, ry;
				REP(i, 10) {
					ry = rand() % RIADKY;
					rx = rand() % STLPCE;
					if (mapa[ry][rx] == UNKNOWN) {
						dx = rx;
						dy = ry;
						isDest = true;
						break;
					}
				}
				
				if (!isDest) {
					dy = rand() % RIADKY;
					dx = rand() % STLPCE;
					isDest = true;
				}
			}
		}
	} // }}}

//	cout << "isPack = " << isPack << " isDest = " << isDest << " [" << dx << ", " << dy << "]" << endl;

	wasdest = false;
	if (isDest) { // movement {{{
		wasdest = true;
		destx = dx;
		desty = dy;
		queue<POINT> Q;
		int visited[MAX_ROZMER][MAX_ROZMER];

		REP(i, RIADKY)
			REP(j, STLPCE)
				visited[i][j] = -1;

		REP(i, 4)
			if(mapa[data.y + sy[i]][data.x + sx[i]] == VOLNO){
				Q.push((POINT) {data.x + sx[i], data.y + sy[i]});
				visited[data.y + sy[i]][data.x + sx[i]] = i;
			}

		int tx, ty, nx, ny;
		while (!Q.empty()) {
			tx = Q.front().x;
			ty = Q.front().y;
			if ((tx == dx) && (ty == dy)) break;
			Q.pop();

			REP(i, 4){
				nx = tx + sx[i];
				ny = ty + sy[i];
				if(visited[ny][nx]==-1 && mapa[ny][nx] != STENA) {
					visited[ny][nx] = visited[ty][tx];
					Q.push((POINT) {nx, ny});
				}
			}
		}

		if(!isPack) ret.rotate = 2;
		else Rotor(data.rotate, data.x, data.y, px, py, ret.rotate);

		if(!Q.empty()) {
			ret.mx = sx[visited[dy][dx]];
			ret.my = sy[visited[dy][dx]];
		} else {
			REP(i, 4)
				if(mapa[data.y + sy[i]][data.x + sx[i]] == VOLNO){
					ret.mx = sx[i];
					ret.my = sy[i];
					break;
				}
		}
//		cout << "movement " << ret.mx << " " << ret.my << endl;

	} // }}}

	return ret;
}

void Finalize(){
	cout << "Owning!!!" << endl;
}
