#include "headers.h"

#define SCREEN_WIDTH  800
#define SCREEN_HEIGHT 600
#define SCREEN_BPP     16

#define TRUE  1
#define FALSE 0

string ip = "127.0.0.1";
int port = 4747;
Logger logger;

Connection* conn;
MapaSend mapa;
MyFont font;

SDL_Surface *surface;
int videoFlags;

int fullscreen=0;

Skybox skybox;

int hp=100, zasobnik, zbytok;
int curweapon=0;

struct Stena 
{
	int x1, x2, y1, y2;
	int nx, ny;
};

struct Ammo
{
	int x, y, t;
};



vector<Ammo> ammo;
//vector<Stena> steny;
//vector<Stena> strechy;

int nplayers;
int playerview=0;
char playerviewnick[110]="";

vector<Player> players;
map<int, Missile*> missiles;

double vyskastrechy = 1.5;
double vyskahraca = 0.95;

//int sound = 0;

void Quit( int returnCode )
{
    /* clean up the window */
    SDL_Quit( );

    /* and exit appropriately */
    exit( returnCode );
}

const int px1[]={1,0,0,0};
const int px2[]={1,1,0,1};
const int py1[]={0,1,0,0};
const int py2[]={1,1,1,0};

int g_width, g_height;

GLfloat LightAmbient[]= { 0.3f, 0.3f, 0.3f, 1.0f }; 
GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightDirection[]= { 0.3f, -0.5f, 0.5f, 0.0f };  

int mapalist;
Texture maptextures[2];

int ammotypes = 5;
char ammotexturefiles[][100] = {"pistola.tga", "broka.tga", "bazookaa.tga", "katusaa.tga", "uzia.tga"};
Texture ammotextures[5];

char missiletexturefiles[][100] = {"bullet.tga", "bullet.tga", "rocket.tga", "rocket.tga", "bullet.tga"};
Texture missiletextures[5];

int exptextures = 2;
Texture explosiontextures[2];
char explosiontexturefiles[][100] = {"expsmall.tga", "explosion.tga"};

int nptex = 15;
Texture playertextures[15];
char playertexturefiles[][100] = {"ppp.tga", "ppb.tga", "ppz.tga", "drp.tga", "drb.tga", "drz.tga", "nlp.tga", "nlb.tga", "nlz.tga", "kspp.tga", "kspb.tga", "kspz.tga", "bwp.tga", "bwb.tga", "bwz.tga"};

Texture cross;
char crossfile[] = {"cross.tga"};

Texture weapontextures[5];
char weapontexturefiles[][100] = {"pistol.tga", "brok.tga", "bazooka.tga", "katusa.tga", "uzi.tga"};

map<string,int> textury;

int lasthp = 100;

void PrepareMap()
{
	vector<Stena> steny;
	vector<Stena> strechy;
	bool s;
	int nx, ny;
	Stena a;
	for(int i = 0; i < mapa.r; i++)
	{
		for(int j = 0; j < mapa.c; j++)
		{
			if(mapa.mapa[i][j]!=STENA){
				a.x1 = j;
				a.x2 = j+1;
				a.y1 = i;
				a.y2 = i+1;
				strechy.push_back(a);
				continue;
			}
			for(int k = 0; k < 4; k++)
			{
				s = false;
				ny = i+sy[k];
				nx = j+sx[k];
				if(ny >= 0 && nx >= 0 && ny < mapa.r && nx < mapa.c)
				{
					if(mapa.mapa[ny][nx]==STENA) s = true;
				}
				if(!s)
				{
					a.x1 = j+px1[k];
					a.x2 = j+px2[k];
					a.y1 = i+py1[k];
					a.y2 = i+py2[k];
					a.nx = sx[k];
					a.ny = sy[k];
					steny.push_back(a);
				}
			}
		}
	}
	char out[100];
	sprintf(out, "pocet stien %d striech %d %d %d %d %d", steny.size(), strechy.size(), strechy[0].x1, strechy[0].x2, strechy[0].y1, strechy[0].y2 );
	logger.Output(MESSAGE, out);
	maptextures[0].Load("trava.bmp");
	maptextures[1].Load("stena.bmp");
	mapalist = glGenLists(1);
	if(playerview==-1) vyskastrechy/=4.0;
	glNewList(mapalist, GL_COMPILE);
		if(playerview==-1){
			glNormal3f(0,1,0);
			glColor3f(0.5,0,0);
			glBegin(GL_QUADS);
			for(int i = 0; i < mapa.r; i++)
				for(int j = 0; j < mapa.c; j++)
				{
					if(mapa.mapa[i][j]==STENA)
					{
						glVertex3f(j,vyskastrechy,i);
						glVertex3f(j+1,vyskastrechy,i);
						glVertex3f(j+1,vyskastrechy,i+1);
						glVertex3f(j,vyskastrechy,i+1);
					}
				}
			glEnd();
		}
		glEnable(GL_TEXTURE_2D);
		maptextures[0].Bind();
		glBegin(GL_QUADS);
		//glBindTexture(GL_TEXTURE_2D, 0);
		glColor3f(1,1,1);
		
		//glVertex3f(0,0,0);
		//glVertex3f(mapa.c,0,0);
		//glVertex3f(mapa.c,0,mapa.r);
		//glVertex3f(0,0,mapa.r);
		for(int i = 0; i < (int)strechy.size(); i++)
		{
			glTexCoord2f(0.0,0.0); glVertex3f(strechy[i].x1, 0, strechy[i].y1);
			glTexCoord2f(1.0,0.0); glVertex3f(strechy[i].x2, 0, strechy[i].y1);
			glTexCoord2f(1.0,1.0); glVertex3f(strechy[i].x2, 0, strechy[i].y2);
			glTexCoord2f(0.0,1.0); glVertex3f(strechy[i].x1, 0, strechy[i].y2);
		}
		glEnd();
		maptextures[1].Bind();
		glBegin(GL_QUADS);
		glColor3f(1,1,1);
		for(int i = 0; i < (int)steny.size(); i++)
		{
			glNormal3f(steny[i].nx,0,steny[i].ny);
			glTexCoord2f(0.0,0.0); glVertex3f(steny[i].x1, 0, steny[i].y1);
			glTexCoord2f(1.0,0.0); glVertex3f(steny[i].x2, 0, steny[i].y2);
			glTexCoord2f(1.0,1.0); glVertex3f(steny[i].x2, vyskastrechy, steny[i].y2);
			glTexCoord2f(0.0,1.0); glVertex3f(steny[i].x1, vyskastrechy, steny[i].y1);
		}
		glColor3f(0.7,0,0);
	/*	for(int i = 0; i < strechy.size(); i++)
		{
		
			glVertex3f(strechy[i].x1, vyskastrechy, -strechy[i].y1);
			glVertex3f(strechy[i].x2, vyskastrechy, -strechy[i].y1);
			glVertex3f(strechy[i].x2, vyskastrechy, -strechy[i].y2);
			glVertex3f(strechy[i].x1, vyskastrechy, -strechy[i].y2);
		}*/
		glEnd();
		maptextures[0].Bind();
		glBegin(GL_TRIANGLES);
			glVertex3f(0,-500,0);
			glVertex3f(0,-500,1);
			glVertex3f(1,-500,0);
		glEnd();
		glDisable(GL_TEXTURE_2D);
	glEndList();
}

int resizeWindow( int width, int height )
{
	g_width = width;
	g_height = height;
    /* Height / width ration */
    GLfloat ratio;
 
    /* Protect against a divide by zero */
    if ( height == 0 )
	height = 1;

    ratio = ( GLfloat )width / ( GLfloat )height;

    /* Setup our viewport. */
    glViewport( 0, 0, ( GLint )width, ( GLint )height );

    /* change to the projection matrix and set our viewing volume. */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );

    /* Set our perspective */
    gluPerspective( 90.0f, 1, 0.001f, 5000.0f );

    /* Make sure we're chaning the model view and not the projection */
    glMatrixMode( GL_MODELVIEW );

    /* Reset The View */
    glLoadIdentity( );

    return( TRUE );
}

int initGL()
{

    glShadeModel( GL_SMOOTH );

    /* Set the background black */
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );

    /* Depth buffer setup */
    glClearDepth( 1.0f );

    /* Enables Depth Testing */
    glEnable( GL_DEPTH_TEST );

    /* The Type Of Depth Test To Do */
    glDepthFunc( GL_LEQUAL );

    /* Really Nice Perspective Calculations */
    glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );

	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);	
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);
	glLightfv(GL_LIGHT1, GL_POSITION,LightDirection);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LightAmbient);
	glEnable(GL_LIGHT1);	
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	font.BuildFont();
	skybox.Load();

	for(int i = 0; i < ammotypes; i++){
		ammotextures[i].LoadTGA(ammotexturefiles[i]);
		missiletextures[i].LoadTGA(missiletexturefiles[i]);
	}
	for(int i = 0; i < exptextures; i++)
		explosiontextures[i].LoadTGA(explosiontexturefiles[i]);

	for(int i = 0; i < nptex; i++)
		playertextures[i].LoadTGA(playertexturefiles[i]);

	for(int i = 0; i < 5; i++)
		weapontextures[i].LoadTGA(weapontexturefiles[i]);

	cross.LoadTGA(crossfile);
//	glEnable(GL_TEXTURE_2D);
    return( TRUE );
}



void InitGraph()
{
	   /* Flags to pass to SDL_SetVideoMode */
    
    /* used to collect events */
    
    /* this holds some info about our display */
    const SDL_VideoInfo *videoInfo;
    /* whether or not the window is active */

    /* initialize SDL */
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
	{
	    fprintf( stderr, "Video initialization failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

	videoInfo = SDL_GetVideoInfo( );

    if ( !videoInfo )
	{
	    fprintf( stderr, "Video query failed: %s\n",
		     SDL_GetError( ) );
	    Quit( 1 );
	}

    /* the flags to pass to SDL_SetVideoMode */
    videoFlags  = SDL_OPENGL;          /* Enable OpenGL in SDL */
    videoFlags |= SDL_GL_DOUBLEBUFFER; /* Enable double buffering */
    videoFlags |= SDL_HWPALETTE;       /* Store the palette in hardware */
    videoFlags |= SDL_RESIZABLE;       /* Enable window resizing */
	if(fullscreen==1)
		videoFlags |= SDL_FULLSCREEN;

    /* This checks to see if surfaces can be stored in memory */
    if ( videoInfo->hw_available )
	videoFlags |= SDL_HWSURFACE;
    else
	videoFlags |= SDL_SWSURFACE;

    /* This checks if hardware blits can be done */
    if ( videoInfo->blit_hw )
	videoFlags |= SDL_HWACCEL;

    /* Sets up OpenGL double buffering */
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

    /* get a SDL surface */
    surface = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,
				videoFlags );

    /* Verify there is a surface */
    if ( !surface )
	{
	    fprintf( stderr,  "Video mode set failed: %s\n", SDL_GetError( ) );
	    Quit( 1 );
	}
	
	/* initialize OpenGL */
    initGL( );

    /* resize the initial window */
    resizeWindow( SCREEN_WIDTH, SCREEN_HEIGHT );

	SDL_ShowCursor(SDL_DISABLE);


	PrepareMap();

}

void Connect()
{
	conn = new Connection;
	logger.Output(MESSAGE, "Connect start");
	while(conn->connect(ip, port)!=0)
		usleep(CONNECT_WAIT_TIME*1000);
	logger.Output(MESSAGE, "Connect success");
	Packet initpacket = conn->receive();
	mapa = *((MapaSend*)initpacket.payload);
	nplayers = mapa.nplayers;
	for(int i = 0; i < nplayers; i++){
		players.push_back(Player());
		strcpy(players[i].nick, mapa.nicks[i]);
		players[i].texture = 3;
		if(textury.count(string(players[i].nick))!=0)
			players[i].texture = textury[string(players[i].nick)];
	}
	logger.Output(MESSAGE, "Mapa prisla");
	if(playerview >= (int)players.size())
		playerview = 0;
	for(int i = 0; i < (int)players.size(); i++)
		if(strcmp(players[i].nick,playerviewnick)==0)
			playerview=i;
	if(strcmp(playerviewnick,"cam")==0)
		playerview=-1;
}

void LoadConfig()
{
	Preferences::createInstance();
	Preferences::_loadFromFile("drawer.cfg");

	//NPLAYERS = Preferences::_getDefaultInt("nplayers", 4);
	//NDRAWERS = Preferences::_getDefaultInt("ndrawers", 4);
	port = Preferences::_getDefaultInt("port", 4747);
	//drawport = Preferences::_getDefaultInt("drawport", 4747);
	ip = Preferences::_getDefaultString("ip", "127.0.0.1");
	fullscreen = Preferences::_getDefaultInt("fullscreen", 0);
	//sound = Preferences::_getDefaultInt("sound", 0);
	int num = 0;
	int tex = -1;
	char str[20];
	string nick;
	while(1)
	{
		sprintf(str, "tex%d", num);
		tex = Preferences::_getDefaultInt(str, -1);
		if(tex==-1) break;
		sprintf(str, "nick%d", num);
		nick = Preferences::_getString(str);
		textury[nick]=tex;
		num++;
	}
}

void Init()
{
	LoadConfig();
	Connect();
	InitGraph();
	logger.Output(MESSAGE, "Init finished");
}

void DrawMap()
{
	//logger.Output(MESSAGE, "DrawMap start");
	/*glBegin(GL_QUADS);
		glColor3f(0,1,0);
		glNormal3f(0,1,0);
		glVertex3f(0,0,0);
		glVertex3f(mapa.c,0,0);
		glVertex3f(mapa.c,0,mapa.r);
		glVertex3f(0,0,mapa.r);
		glColor3f(0.5,0,0);
		for(int i = 0; i < steny.size(); i++)
		{
			glNormal3f(steny[i].nx,0,steny[i].ny);
			glVertex3f(steny[i].x1, 0, steny[i].y1);
			glVertex3f(steny[i].x2, 0, steny[i].y2);
			glVertex3f(steny[i].x2, vyskastrechy, steny[i].y2);
			glVertex3f(steny[i].x1, vyskastrechy, steny[i].y1);
		}
		glColor3f(0.7,0,0);
	glEnd();*/
	glCallList(mapalist);
	//logger.Output(MESSAGE, "DrawMap end");
}

void SetCamera()
{
	//logger.Output(MESSAGE, "SetCamera start");
	//printf("%d %d\n", nplayers, playerview);
	/* Reset the view */
    glLoadIdentity( );

    /* Translate Into/Out Of The Screen By z */
	if(playerview!=-1)
    gluLookAt(players[playerview].x+0.5, vyskahraca*0.8, players[playerview].y+0.5,
			  players[playerview].tx+0.5, vyskahraca*0.8, players[playerview].ty+0.5, 0, 1, 0);
	else{
		timeval tv;
		gettimeofday(&tv, NULL);
		long double d = tv.tv_sec+tv.tv_usec*0.000001;
		
		gluLookAt(mapa.c/2+sin(d/3)*mapa.c*0.7, 10, mapa.r/2+cos(d/3)*mapa.r*0.7,
			  mapa.c/2, 0, mapa.r/2, 0, 1, 0);
	}
	//logger.Output(MESSAGE, "SetCamera end");
}

void ShowData()
{
	glDisable(GL_LIGHTING);
	glLoadIdentity();
	glTranslatef( 0.0f, 0.0f, -0.1f );

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(0,g_width,0,g_height,-10,1000);
	glMatrixMode( GL_MODELVIEW );

	glColor3f(1,0,0);
	
	glRasterPos2f( g_width-100, 40 );
	//glWindowPos2i(0,0);
	if(playerview!=-1){
	font.Print("HP: %d", hp);
	glRasterPos2f( g_width-100, 20 );
	font.Print("%d/%d", zasobnik,zbytok);
	}
	for(int i = 0; i < (int)players.size(); i++)
	{
		if(i==playerview)glColor3f(1,1,1);
		else glColor3f(0,0,1);
		//gluUnProject(10,10,1,model,proj,view,&x,&y,&z);
		//printf("%d %d %d %d %lf %lf %lf\n", view[0], view[1], view[2], view[3], x, y, z);
		glRasterPos2f( 2+(i%2)*g_width/2, g_height-20-(i/2)*20 );
		font.Print("%s: %d/%d", players[i].nick, players[i].frags,players[i].deaths);
	}
	if(playerview!=-1){
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0);
	glEnable(GL_TEXTURE_2D);
	cross.Bind();
	glColor3f(0.2,1,0.2);
	//printf("%d %d\n", g_width, g_height);
	//glRasterPos2f(320, 1);
	glLoadIdentity();
	glTranslatef(g_width/2, g_height/2,-0.1);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0,1.0); glVertex3f(-10,-10,0);
		glTexCoord2f(1.0,1.0); glVertex3f(10,-10,0);
		glTexCoord2f(1.0,0.0); glVertex3f(10,10,0);
		glTexCoord2f(0.0,0.0); glVertex3f(-10,10,0);
	glEnd();

	glLoadIdentity();
	weapontextures[curweapon].Bind();
	glTranslatef(g_width-80, 80,-0.1);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0,1.0); glVertex3f(-30,-15,0);
		glTexCoord2f(1.0,1.0); glVertex3f(30,-15,0);
		glTexCoord2f(1.0,0.0); glVertex3f(30,15,0);
		glTexCoord2f(0.0,0.0); glVertex3f(-30,15,0);
	glEnd();

	glDisable(GL_ALPHA_TEST);
	glDisable(GL_TEXTURE_2D);
	if(hp < lasthp){
		glLoadIdentity();
		glTranslatef(0,0,-0.1);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(1,0,0,0.3);
		glBegin(GL_QUADS);
			glVertex3f(0,0,0);
			glVertex3f(g_width,0,0);
			glVertex3f(g_width,g_height,0);
			glVertex3f(0,g_height,0);
		glEnd();
		glDisable(GL_BLEND);
	}
//	font.Print("+");
	}
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 90.0f, 1, 0.001f, 5000.0f );
	glMatrixMode( GL_MODELVIEW );
}

void DrawAmmo()
{
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0);
	for(int i = 0; i < (int)ammo.size(); i++)
	{
		ammotextures[ammo[i].t].Bind();
		glPushMatrix();
		glTranslatef(ammo[i].x+0.5, 0.1, ammo[i].y+0.5);
		glRotatef(atan2(players[playerview].x-ammo[i].x,players[playerview].y-ammo[i].y)/3.14159*180, 0,1,0);
		//if(
		glColor3f(1,1,1);
		glBegin(GL_QUADS);
			//glColor3f(0,0.8,0.
			glTexCoord2f(0.0,1.0); glVertex3f(-0.2,0,0);
			glTexCoord2f(1.0,1.0); glVertex3f(0.2,0,0);
			glTexCoord2f(1.0,0.0); glVertex3f(0.2,0.4,0);
			glTexCoord2f(0.0,0.0); glVertex3f(-0.2,0.4,0);
		glEnd();
		glPopMatrix();
	}
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_TEXTURE_2D);
}

int drawGLScene()
{
	//logger.Output(MESSAGE, "Draw start");
    /* These are to calculate our fps */
    //static GLint T0     = 0;
    //static GLint Frames = 0;
	//static double yrot;

    /* Clear The Screen And The Depth Buffer */
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glEnable(GL_LIGHTING);
	
	SetCamera();

	glLightfv(GL_LIGHT1, GL_POSITION,LightDirection);

	skybox.Draw(players[playerview].x, players[playerview].y);

	DrawMap();

	//logger.Output(MESSAGE, "Mapa vykreslena");

	for(int i = 0; i < nplayers; i++){
		if(i == playerview) continue;
		players[i].Draw();
	}
	
	//logger.Output(MESSAGE, "Hraci vykresleni");

	DrawAmmo();

	//logger.Output(MESSAGE, "Ammo vykreslene");
	glDisable(GL_LIGHTING);
	for(map<int,Missile*>::iterator it = missiles.begin(); it!=missiles.end(); it++)
		(*it).second->Draw();
	
	ShowData();
	
    /* Draw it to the screen */
    SDL_GL_SwapBuffers( );

    //xrot += xspeed; /* Add xspeed To xrot */
    //yrot += 0.1; /* Add yspeed To yrot */

	static int lasttime = time(NULL);
	static int count = 0;
	int curtime = time(NULL);
	if(curtime-2>lasttime){
		printf("%lf fps\n", (double)count/(double)(curtime-lasttime));
		printf("municii %d\n", ammo.size());
		lasttime = curtime; count=0;
	}
	else
		count++;

	//logger.Output(MESSAGE, "Draw end");

    return( TRUE );
}

void Update()
{
	static bool active = true;
	//logger.Output(MESSAGE, "Update start");
	Packet packet;
	if(!active) return;
	if(conn->receive_async(packet)==0)
	{
		//logger.Output(MESSAGE, "In");
		ammo.clear();
		DrawSend send = *((DrawSend*)packet.payload);
		if(send.nObjects==-1)
		{
			logger.Output(MESSAGE, "The end");
			active = false;
			delete conn;
			return;
		}
		for(int i = 0; i < nplayers; i++){
			//printf("target %d: %d %d\n", i,send.objects[i].y,send.objects[i].x);
			players[i].SetTarget(send.objects[i].y, send.objects[i].x, send.objects[i].rotate);
			if(send.objects[i].spawned)
				players[i].SetTarget(send.objects[i].y, send.objects[i].x, send.objects[i].rotate);
			players[i].frags = send.stats[i][0];
			players[i].deaths = send.stats[i][1];
		}
		//printf("no %d\n", send.nObjects);
		for(int i = nplayers; i < send.nObjects; i++)
		{
			//printf("type %d\n", send.objects[i].type);
			if(send.objects[i].type >= OBJECT_AMMO)
			{
				Ammo a;
				a.x = send.objects[i].x;
				a.y = send.objects[i].y;
				a.t = send.objects[i].type-OBJECT_AMMO;
				ammo.push_back(a);
			}
			else if(send.objects[i].type >= OBJECT_MISSILE)
			{
				//printf("strela\n");
				if(missiles.count(send.objects[i].id)==0)
				{
					printf("strela\n");
					Missile *a = new Missile((send.objects[i].type-OBJECT_MISSILE)%100);
					missiles[send.objects[i].id]=a;
					missiles[send.objects[i].id]->speed=(send.objects[i].type-OBJECT_MISSILE)/100;
					missiles[send.objects[i].id]->SetTarget(send.objects[i].y, send.objects[i].x, send.objects[i].rotate);
				}
				missiles[send.objects[i].id]->SetTarget(send.objects[i].y, send.objects[i].x, send.objects[i].rotate);
				if(send.objects[i].spawned==false){ missiles[send.objects[i].id]->Detonate();}
			}
		}
		if(playerview!=-1){
		curweapon = send.objects[playerview].id%5;
		send.objects[playerview].id/=5;
		lasthp=hp;
		hp = send.objects[playerview].id%MAX_HP;
		zasobnik = (send.objects[playerview].id/MAX_HP)%MAX_ZASOBNIK;
		zbytok = (send.objects[playerview].id/MAX_HP)/MAX_ZASOBNIK;
		}
		delete packet.payload;
		for(map<int,Missile*>::iterator it = missiles.begin(); it != missiles.end(); it++)
			(*it).second->Tick();
	}
	for(int i = 0; i < nplayers; i++)
		players[i].Update();
	vector<int> del;
	for(map<int,Missile*>::iterator it = missiles.begin(); it != missiles.end(); it++)
	{
		if(!((*it).second->Update()))
			del.push_back((*it).first);
	}
	for(int i = 0; i < (int)del.size(); i++)
	{
		printf("erased\n");
		missiles.erase(del[i]);
	}
	//logger.Output(MESSAGE, "Update finished");
}

void Loop()
{
	/* main loop variable */
    int done = FALSE;
	SDL_Event event;
	int isActive = TRUE;
	/* wait for events */
    while ( !done )
	{
	    /* handle the events in the queue */

	    while ( SDL_PollEvent( &event ) )
		{
		    switch( event.type )
			{
			case SDL_ACTIVEEVENT:
			    /* Something's happend with our focus
			     * If we lost focus or we are iconified, we
			     * shouldn't draw the screen
			     */
			    if ( event.active.gain == 0 )
				isActive = FALSE;
			    else
				isActive = TRUE;
			    break;			    
			case SDL_VIDEORESIZE:
			    /* handle resize event */
			    surface = SDL_SetVideoMode( event.resize.w,
							event.resize.h,
							16, videoFlags );
			    if ( !surface )
				{
				    fprintf( stderr, "Could not get a surface after resize: %s\n", SDL_GetError( ) );
				    Quit( 1 );
				}
			    resizeWindow( event.resize.w, event.resize.h );
			    break;
			case SDL_KEYDOWN:
			    /* handle key presses */
			//    handleKeyPress( &event.key.keysym );
				if(event.key.keysym.sym==SDLK_F3)
					done = 1;
			    break;
			case SDL_QUIT:
			    /* handle quit requests */
			    done = 1;
			    break;
			default:
			    break;
			}
		}
		
		//logger.Output(MESSAGE, "aaaa");
		Update();
		//logger.Output(MESSAGE, "cccc");
	    /* draw the scene */
	    //if ( isActive )
		drawGLScene( );
		usleep(100);
		//logger.Output(MESSAGE, "bbbb");
	}
}

void Clean()
{
	Quit( 0 );
}

int main(int argc, char **argv)
{
	if(argc > 1)
	{
		strcpy(playerviewnick,argv[1]);
		playerview = atoi(argv[1]);
	}
	logger.SetWarnLevel(MESSAGE);
	Init();
	Loop();
	Clean();
	return 0;
}
