#include "headers.h"

extern Texture missiletextures[3];
extern Texture explosiontextures[2];
extern Texture playertextures[3];

extern vector<Player> players;
extern int playerview;
extern double vyskahraca;

bool Object::Update()
{
	long long dif;
	timeval tv;
	gettimeofday(&tv, NULL);
	dif = 1000000*tv.tv_sec+tv.tv_usec-lastupdate;
	double st = (double)dif/((double)ROUND_SLEEP_TIME*1000);
	if(st>1) st=1;
	x = (double)x0+((double)(x1-x0))*st;
	y = (double)y0+((double)(y1-y0))*st;
	double tx0, tx1;
	double ty0, ty1;
	tx0 = x+smerx[r0];
	ty0 = y+smery[r0];
	tx1 = x+smerx[rot];
	ty1 = y+smery[rot];
	tx = tx0+(tx1-tx0)*st;
	ty = ty0+(ty1-ty0)*st;
	return true;
}

void Object::SetTarget(int y, int x, int r)
{
	x0 = x1; y0 = y1; r0 = rot;
	x1 = x; y1 = y; rot = r;
	timeval tv;
	gettimeofday(&tv, NULL);
	lastupdate = 1000000*tv.tv_sec+tv.tv_usec;
}

void Player::Draw()
{
	glPushMatrix();
	glTranslatef(x+0.5, 0, y+0.5);
	glRotatef(atan2(players[playerview].x-x,players[playerview].y-y)/3.14159*180, 0,1,0);
	double vect = (players[playerview].x-x)*smerx[rot]+(players[playerview].y-y)*smery[rot];
	vect/=sqrt((players[playerview].x-x)*(players[playerview].x-x)+(players[playerview].y-y)*(players[playerview].y-y));
	vect/=sqrt(smery[rot]*smery[rot]+smerx[rot]*smerx[rot]);
	//printf("%lf\n", vect);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
		glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glAlphaFunc(GL_GREATER, 0);
	if(fabs(vect)<0.707){
		double v2 = (players[playerview].x-x)*smery[rot]-(players[playerview].y-y)*smerx[rot];
		if(v2<0) glRotatef(180,0,1,0);
		playertextures[3*texture+1].Bind();
	}
	else if(vect>0) playertextures[3*texture].Bind();
	else playertextures[3*texture+2].Bind();
	glColor3f(1,1,1);
		glBegin(GL_QUADS);
			//glColor3f(0,0.8,0.
			glTexCoord2f(0.0,1.0); glVertex3f(-vyskahraca/2.0,0,0);
			glTexCoord2f(1.0,1.0); glVertex3f(vyskahraca/2.0,0,0);
			glTexCoord2f(1.0,0.0); glVertex3f(vyskahraca/2.0,vyskahraca,0);
			glTexCoord2f(0.0,0.0); glVertex3f(-vyskahraca/2.0,vyskahraca,0);
		glEnd();
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	glPopMatrix();
}

void Missile::Draw()
{
	if(time < 2) return;
	if(det!=2)
	{
		glEnable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		missiletextures[type].Bind();
		glPushMatrix();
	//	printf("su %lf %lf\n", x, y);
		glTranslatef(x+0.5, 0, y+0.5);
		glRotatef(atan2(x1-x0,y1-y0)/3.14159*180, 0,1,0);
		glColor4f(1,1,1,detphase);
		glBegin(GL_QUADS);
		/*if(type==BAZOOKA)
			glColor4f(0.2,0.2,0.8,0.85);
		else 
			glColor4f(0.2,0.2,0.2,0.45);*/
			glTexCoord2f(0,0); glVertex3f(0.01,0.45,-0.4);
			glTexCoord2f(1,0); glVertex3f(0.01,0.45,0.4);
			glTexCoord2f(1,0.2);glVertex3f(-0.01,0.47,0.4);
			glTexCoord2f(0,0.2);glVertex3f(-0.01,0.47,-0.4);
		glEnd();
		glPopMatrix();
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
	}
	else
	{
		//glDisable( GL_DEPTH_TEST );
		//if(!hasexp[type])return;
		glEnable(GL_BLEND);
		glEnable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		if(hasexp[type])
			explosiontextures[1].Bind();
		else
			explosiontextures[0].Bind();
		glPushMatrix();
		glTranslatef(ex, 0.46, ey);
		/*if(y1!=y0||x1!=x0)
			glRotatef(atan2(y1-y0,x0-x1)/3.14159*180, 0,1,0);
		else{
			//printf("druha %d %d\n", smery[rot],smerx[rot]);
			glRotatef(atan2(smery[rot],-smerx[rot])/3.14159*180, 0,1,0);
		}*/
		double factor;
		if(hasexp[type]) factor=4.5;
		else factor=0.4;
		printf("det %lf %lf 0: %d %d 1: %d %d dp: %lf %lf %d\n", ex, ey, x0, y0, x1, y1, detphase, factor, type);
		glScalef(factor+factor*detphase,factor+factor*detphase,factor+factor*detphase);
		glColor4f(1,1,1,0.7-0.7*detphase);
		glBegin(GL_QUADS);
			glTexCoord2f(0,0); glVertex3f(0,-0.1,-0.1);
			glTexCoord2f(1,0); glVertex3f(0,-0.1,0.1);
			glTexCoord2f(1,1); glVertex3f(-0,0.1,0.1);
			glTexCoord2f(0,1); glVertex3f(-0,0.1,-0.1);
			glTexCoord2f(0,0); glVertex3f(-0.1,-0.1,0);
			glTexCoord2f(1,0); glVertex3f(0.1,-0.1,0);
			glTexCoord2f(1,1); glVertex3f(0.1,0.1,-0);
			glTexCoord2f(0,1); glVertex3f(-0.1,0.1,-0);
		glEnd();
		glPopMatrix();
		glDisable(GL_TEXTURE_2D);
		glDisable(GL_BLEND);
		//glEnable( GL_DEPTH_TEST );
	}
}

bool Missile::Update()
{   
	if(det==-1)
		Object::Update();
	long long dif;
	timeval tv;
	gettimeofday(&tv, NULL);
	if(stx == -1 && sty == -1){
		stx=x0; sty=y0;}
	if(det!=2)
	{
		detphase = fabs(x-stx)+fabs(y-sty);
		if(detphase>1) detphase=1;
		//detphase=1;
	}
	if(det==-1) return true;
	if(det==1){
		dif = 1000000*tv.tv_sec+tv.tv_usec-lastupdate;
		double vzd = abs(x1-x0)+abs(y1-y0);
		double part = vzd/(6.0*speed);
		double st = 0;
		if(vzd!=0)
			st = (double)dif/((double)ROUND_SLEEP_TIME*1000*part);
		if(st>=1 || vzd==0)
		{
			x = x1+0.5; y = y1+0.5;
			ex = x; ey=y;
			if(smerx[rot]<0) ex-=0.49; 
			if(smerx[rot]>0) ex+=0.49;
			if(smery[rot]<0) ey-=0.49; 
			if(smery[rot]>0) ey+=0.49;
			det = 2;
			dettime = 1000000*tv.tv_sec+tv.tv_usec;
			detphase = 0;
			return true;
		}
		x = (double)x0+((double)(x1-x0))*st;
		y = (double)y0+((double)(y1-y0))*st;
		//printf("su %Lf %Lf\n", x, y);
		//if(det==0) return false;
		return true;
	}
	dif = 1000000*tv.tv_sec+tv.tv_usec-dettime;
	detphase = (double)dif/((double)ROUND_SLEEP_TIME*1000);
	if(detphase>=1) return false;
	return true;
}

void Missile::Detonate()
{
	det=1;
}

void Missile::Tick()
{
	time++;
}