#ifndef OBJECT_H
#define OBJECT_H

class Object
{
public:
	double x, y;
	double tx, ty;
	int r0;
	int x0, y0, rot, x1, y1;
	long long lastupdate;
	Object(){};
	void Create()
	{
		timeval tv;
		gettimeofday(&tv, NULL);
		lastupdate = 1000000*tv.tv_sec+tv.tv_usec;
	}
	virtual bool Update();
	void SetTarget(int y, int x, int r);
	virtual void Draw()=0;
};

class Player : public Object
{
public:
	char nick[MAX_NICK];
	int texture;
	int frags, deaths;
	Player(){ x=0; y=0; rot=0; r0=0; texture=0;};
	virtual void Draw();
};

const bool hasexp[] = {false,false,true,true,false};

class Missile : public Object
{
public:
	int type;
	int det;
	int time;
	int speed;
	int stx, sty;
	long long dettime;
	double detphase;
	double ex,ey;
	Missile() {type=0; det=-1;time=0;detphase=0; stx=-1; sty=-1;};
	Missile(int t) {type=t; x=y=rot=r0=0; det=-1;time=0; detphase=0; stx=-1; sty=-1;}
	virtual void Draw();
	virtual bool Update();
	void Detonate();
	void Tick();
};

#endif