#include "headers.h"

Logger logger;

string ip = "127.0.0.1";
int port = 4742;
extern char nick[];

extern int RIADKY, STLPCE;

Connection* conn;

int LoadConfig()
{
	Preferences::createInstance();
	Preferences::_loadFromFile("client.cfg");

	//NPLAYERS = Preferences::_getDefaultInt("nplayers", 4);
	//NDRAWERS = Preferences::_getDefaultInt("ndrawers", 4);
	port = Preferences::_getDefaultInt("port", 4742);
	//drawport = Preferences::_getDefaultInt("drawport", 4747);
	ip = Preferences::_getDefaultString("ip", "127.0.0.1");
	return 1;
}

int Init()
{
	if(LoadConfig()==0) return 0;
	conn = new Connection;
	conn->connect(ip, port);
	if(!conn->good()) return 0;

	Packet initpacket = conn->receive();
	GameData data = *((GameData*)initpacket.payload);
	if(data.type != TYPE_INIT){
		logger.Output(ERROR, "Nejaky fail neprisiel init packet");
		return 0;
	}
	RIADKY = data.y;
	STLPCE = data.x;
	fprintf(stderr, "RIADKY %d COLS %d\n", RIADKY, STLPCE);
	ClientInit cinit;
	Packet cinitpacket;
	if(strlen(nick)>MAX_NICK) nick[MAX_NICK]=0;
	strcpy(cinit.nick, nick);
	cinitpacket.len = sizeof(cinit);
	cinitpacket.payload = &cinit;
	conn->send(cinitpacket);
	Initialize();
	logger.Output(MESSAGE, "Init finished");
	return 1;
}

void Run()
{
	Packet data, data2;
	GameData gamedata;
	Action act;
	bool active=true;
	while(active)
	{
		data = conn->receive();
		gamedata = *((GameData*)data.payload);
		switch(gamedata.type)
		{
			case TYPE_ROUND:
				act = Step(gamedata);
				data2.payload = &act;
				data2.len = sizeof(act);
				conn->send(data2);
				break;
			case TYPE_END:
				logger.Output(MESSAGE, "The end");
				delete conn;
				active = false;
				break;
		}
		delete data.payload;
	}
}

int main()
{
	logger.SetWarnLevel(MESSAGE);
	if(Init()==0){
		logger.Output(ERROR, "Init failed");
		return 0;
	}
	Run();
	Finalize();
	return 0;
}