/** ========== [ heading ] ========== **/

#include <cstring>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <vector>
using namespace std;

#include "headers.h"
#include "../helpers.h"

#define INF 987654321
#define PI 3.141592653589

int RIADKY, STLPCE;

char nick[]="007";

char *M,*A,*P;
int R,C;

/** ========== [ state - def ] ========== **/

#define AG_ROAM 0
#define AG_MOVE 1
#define AG_FIGHT 2

#define SEEK_BEGIN_RANGE 6
#define SEEK_END_RANGE 12
#define SEEK_CLOSE_ENOUGH 3
#define FIRE_RANGE 6
#define COOLDOWN 4

int state=AG_ROAM;

int dx=0,dy=-1,drot=0,cooldown,weap=NOTHING;

int tgtx=-1,tgty=-1;

/** ========== [ pathfinding ] ========== **/

void dir2xy(int d, int &dx, int &dy) {
  switch(d) {
    case 1:  dx=00; dy=+1; break;
    case 2:  dx=+1; dy=00; break;
    case 3:  dx=00; dy=-1; break;
    case 4:  dx=-1; dy=00; break;
    default: dx=00; dy=00;
  }
}

void dir2xy(char c, int &dx, int &dy) {
  switch(c) {
    case 'S': case 's': dx=00; dy=+1; break;
    case 'E': case 'e': dx=+1; dy=00; break;
    case 'N': case 'n': dx=00; dy=-1; break;
    case 'W': case 'w': dx=-1; dy=00; break;
    default:  dx=00; dy=00;
  }
}

char dir2CHAR(int d) {
  switch(d) {
    case 1: return 'S';
    case 2: return 'E';
    case 3: return 'N';
    case 4: return 'W';
  }
  return '!';
}

char dir2char(int d) {
  switch(d) {
    case 1: return 's';
    case 2: return 'e';
    case 3: return 'n';
    case 4: return 'w';
  }
  return '!';
}

void dir2revxy(char c,int &dx,int &dy) {
  switch(c) {
    case 'N': case 'n': dx=00; dy=+1; break;
    case 'W': case 'w': dx=+1; dy=00; break;
    case 'S': case 's': dx=00; dy=-1; break;
    case 'E': case 'e': dx=-1; dy=00; break;
    default:  dx=00; dy=00;
  }
}

/// rewrite path to tracable
bool backtrack(char *A,int sx,int sy,int tx,int ty) {
  printf("Hm.\n");
  int x=sx;
  int y=sy;
  int dx,dy;

  stack<int> T;
  while(A[x+y*C]!='!') {
    T.push(x+y*C);
    dir2revxy(A[x+y*C],dx,dy);
    x+=dx; y+=dy;
  }
  
  T.push(x+y*C);
  printf("Hm2.\n");
  while(!T.empty()) {
    int next=T.top(); T.pop();
    int prev=T.top();
    A[next]=A[prev];
    if('a'<=A[next] && A[next]<='z') A[next]+='A'-'a';
  }

  return true;
}

/// find a path
bool path_find(char *A,int sx,int sy,int tx,int ty) {
  printf("Path.\n");
  for(int y=0; y<R; y++) for(int x=0; x<C; x++) A[x+y*C]=M[x+y*C];
  queue<int> Q;
  Q.push(sx); Q.push(sy);
  A[sx+sy*C]=dir2char(0);
  while(!Q.empty()) {
    int x=Q.front(); Q.pop();
    int y=Q.front(); Q.pop();
    if((tx==x) && (ty==y)) {
      backtrack(A,tx,ty,sx,sy);
      printf("Path found.\n");
      return true;
    }
    for(int i=1; i<=4; i++) {
      int dx,dy;
      dir2xy(i,dx,dy);
      int x1=x+dx;
      int y1=y+dy;
      if(A[y1*C+x1]=='.') { A[y1*C+x1]=dir2char(i); Q.push(x1); Q.push(y1); }
    }
  }
  printf("Path not found.\n");
  return false;
}

/// return path length
int path_length(char* B,int sx,int sy,int tx,int ty) {
  printf("Length.\n");
  for(int y=0; y<R; y++) for(int x=0; x<C; x++) B[x+y*C]=M[x+y*C];
  queue<int> Q;
  int d=0;
  Q.push(sx); Q.push(sy);

  Q.push(-1); Q.push(-1);
  B[sx+sy*C]='o';
  while(!Q.empty()) {
    int x=Q.front(); Q.pop();
    int y=Q.front(); Q.pop();
    if(x==-1) {
      d++;
      if(Q.empty()) return INF;
      continue;
    }
    if((tx==x) && (ty==y)) {
      for(int y=0; y<R; y++) for(int x=0; x<C; x++) if(B[x+y*C]=='o') B[x+y*C]='.';
      printf("Length found.\n");
      return d;
    }
    for(int i=1; i<=4; i++) {
      int dx,dy;
      dir2xy(i,dx,dy);
      int x1=x+dx;
      int y1=y+dy;
      if(B[y1*C+x1]=='.') { B[y1*C+x1]='o'; Q.push(x1); Q.push(y1); }
    }
  }
  for(int y=0; y<R; y++) for(int x=0; x<C; x++) if(B[x+y*C]=='o') B[x+y*C]='.';
  printf("Length not found.\n");
  return -1;
}

/** ========== [ objects ] ========== **/

/// position

struct pos {
  int x;
  int y;
  pos() { x=-1; y=-1; }
  pos(int ax,int ay) { x=ax; y=ay; }
};

bool operator< (pos A, pos B) {
  if(A.x==B.x) return A.y<B.y;
  return A.x<B.x;
}

bool operator== (pos A, pos B) {
  return (A.x==B.x) && (A.y==B.y);
}

pos operator- (pos A, pos B) {
  return pos(A.x-B.x,A.y-B.y);
}

pos objpos(const ObjectData &O) {
  return pos(O.x,O.y);
}

bool operator< (ObjectData A, ObjectData B) {
  if(A.x!=B.x) return A.x < B.x;
  if(A.y!=B.y) return A.y < B.y;
  if(A.rotate!=B.rotate) return A.rotate < B.rotate;
  return A.id < B.id;
}

int sgn(int x) {
  if(x==0) return 0;
  return x/abs(x);
}

typedef map<pos,ObjectData> objmap;
typedef objmap::iterator objit;


/// ammo

objmap ammopacks;

bool ammo_there(int x,int y) {
  return ammopacks.find(pos(x,y))!=ammopacks.end();
}

bool ammo_erase(int x,int y) {
  for(objit it=ammopacks.begin(); it!=ammopacks.end(); it++)
    if(it->first == pos(x,y)) { ammopacks.erase(it); return 1; }
  return 0;
}

void ammo_add(ObjectData data) {
  ammopacks[objpos(data)]=data;
}

ObjectData ammo_closest(int x,int y) {
  ObjectData data;
  int min=INF;
  for(objit it=ammopacks.begin(); it!=ammopacks.end(); it++) {
    int d=path_length(A,x,y,it->first.x,it->first.y);
    if(d<min) { d=min; data=it->second; }
  }
  return data;
}


/// players

vector<pos> players;

void play_add(ObjectData data) {
  players.push_back(objpos(data));
}

void play_clear() {
  players.resize(0);
}

bool play_there(int x,int y) {
  for(int i=0; i<players.size(); i++) if(players[i]==pos(x,y)) return 1;
  return 0;
}

pos play_closest(int x,int y) {
  pos data;
  int min=INF;
  for(int i=0; i<players.size(); i++) {
    int d=path_length(P,x,y,players[i].x,players[i].y);
    if(d<min) { d=min; data=players[i]; }
  }
  return data;
}


/** ========== [ core ] ========== **/

void shoot(const GameData &data) {
  if(data.zasobniky[data.curweapon]>0) { weap=SHOT; return; }
  for(int i=0; i<5; i++) if(data.zasobniky[i]>0) { weap = CHANGE_WEAPON+i; return; }
  for(int i=0; i<5; i++) if(data.zbytky[i]>0) { weap = RELOAD; return; }
  printf("OMFG!!!\n");
}

void idle(const GameData &data) {
  for(int i=0; i<5; i++) if(data.zasobniky[i]==0 && data.zbytky[i]>0) { weap = RELOAD; return; }
  printf("Eh ...\n");
}

void state2roam() {
  for(int y=0; y<R; y++)
    for(int x=0; x<C; x++) {
      int c=A[x+y*C];
      if(c=='N' || c=='W' || c=='S' || c=='E' ||
         c=='n' || c=='w' || c=='s' || c=='e' || c=='!') A[x+y*C]='.';
    }
  state=AG_ROAM;
}

void move2ammo(int x,int y,int &dx,int &dy) {
  if(x==tgtx && y==tgty) {
    printf("Picked up ammo. *cheers*\n");
    ammo_erase(x,y);
    state2roam();
    return;
  }
  dir2xy(A[x+y*C],dx,dy);
  printf("Moving.\n");
}

void pursue(int x0,int y0,int rot,const GameData &data) {
  if(!players.size()) {
    printf("Is he cloaked?\n");
    cooldown--;
    if(!cooldown) state2roam();
    return;
  }
  pos p = play_closest(x0,y0);
  int d = path_length(P,x0,y0,p.x,p.y);
  if(d>=SEEK_END_RANGE) {
    printf("He fled ...\n");
    cooldown--;
    if(!cooldown) state2roam();
    return;
  }
  if(d==-1) { printf("WTF?!\n"); drot=0; return; }

  cooldown=COOLDOWN;

  //aim
  pos T=p-pos(x0,y0);
  double alpha = atan2(T.y,T.x);
  d=round(8*alpha/PI);
  drot=d-rot;
  if(drot>+2) drot=+2;
  if(drot<-2) drot=-2;
  shoot(data);

  //move
  printf("Search, Seek & Destroy.\n");
  dx=dy=0;
  if(d<=SEEK_CLOSE_ENOUGH) return;
//  path_find(P,x0,y0,p.x,p.y);
//  dir2xy(P[x0+y0*C],dx,dy);
  if(abs(T.x)>abs(T.y)) { dy=0; dx=sgn(T.x); }
    else { dx=0; dy=sgn(T.y); }
}

void Initialize()
{
  R = RIADKY;
  C = STLPCE;
  M = new char[100*100*1];  memset(M,'?',100*100*1); M+=0*100*100;
  A = new char[100*100*1];  memset(A,'?',100*100*1); A+=0*100*100;
  P = new char[100*100*1];  memset(P,'?',100*100*1); P+=0*100*100;
}

Action Step(const GameData &data)
{
  int x0=data.x; int y0=data.y; int rot=data.rotate;

  /// update map knowledge
  for(int r=0; r<R; r++)
    for(int c=0; c<C; c++) if(M[r*C+c]=='?') {
      if(data.mapa[r][c]==VOLNO) M[r*C+c]='.';
      if(data.mapa[r][c]==STENA) M[r*C+c]='X';
    }

/*
  // debug output
  printf("<MAP>\n");
  for(int r=0; r<R; r++) {
    for(int c=0; c<C; c++) {
      bool b=1;
      if(b && (x0==c) && (y0==r)) { b=0; putchar('0'); }
      if(b && ammo_there(c,r) )   { b=0; putchar('A'); }
      if(b && play_there(c,r) )   { b=0; putchar('@'); }
      if(b) putchar(M[r*C+c]);
    }
    putchar(' ');putchar(' ');putchar(' ');putchar(' ');
    for(int c=0; c<C; c++) putchar(A[r*C+c]);
    putchar(' ');putchar(' ');putchar(' ');putchar(' ');
    for(int c=0; c<C; c++) putchar(P[r*C+c]);
    printf("\n");
  }
  printf("</MAP>\n");
*/
  printf("\n");

  // observe objects
  play_clear();
  for(int i=0; i<data.nObjects; i++) {
    if(data.objects[i].type==OBJECT_PLAYER) {
      play_add(data.objects[i]);
    }
    if(data.objects[i].type-OBJECT_MISSILE < 47) {
      // panic();
    }
    if(data.objects[i].type-OBJECT_AMMO >= 0) {
      ammo_add(data.objects[i]);
    }
  }

  /// take a course of action
  int x1=x0+dx;  int y1=y0+dy;
  idle(data);
  switch(state) {
    // when roaming
    case AG_ROAM:
      if(players.size()) {
        pos p = play_closest(x0,y0);
        int d = path_length(P,x0,y0,p.x,p.y);
        if(d<=SEEK_BEGIN_RANGE) {
          printf("Found player.\n");
          state=AG_FIGHT;
          pursue(x0,y0,rot,data);
          break;
        }
      }
      if(!ammopacks.empty()) {
        printf("Found ammo.\n");
        ObjectData data=ammo_closest(x0,y0);
        tgtx=data.x; tgty=data.y;
        path_find(A,x0,y0,data.x,data.y);
        state=AG_MOVE;
        move2ammo(x0,y0,dx,dy);
      } else {
        printf("Roaming.\n");
        do {
          int d=rand()%4+1;
          dir2xy(d,dx,dy);
          x1=x0+dx; y1=y0+dy;
        } while(M[y1*C+x1]!='.');
        drot=+2;
      }
      break;

    // when moving to pick up ammopack
    case AG_MOVE:
      drot=+2;
      move2ammo(x0,y0,dx,dy);
      break;

    case AG_FIGHT
:
      pursue(x0,y0,rot,data);
      break;

  }

  // output action
  Action ret;
  ret.mx=dx;
  ret.my=dy;
  ret.rotate=drot;
  if(weap==SHOT)   printf("!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
  if(weap==RELOAD) printf("??????????????????????????\n");
  ret.weaponaction=weap;
  return ret;
}

void Finalize()
{
  delete[] M;
  delete[] A;
  delete[] P;
}