#include "mapa.h"

#include <stdio.h>

Mapa::Mapa()
{
}

void Mapa::Generate(int &R, int &C, int seed)
{
	FILE *file = fopen("mapa.dat", "r");
	fscanf(file, "%d %d", &R, &C);
	mapa.resize(R);
	for(int i = 0; i < R; i++){
		mapa[i].resize(C);
	}
	char riadok[150];
	for(int i = 0; i < R; i++){
		fscanf(file, "%s", riadok);
		for(int j = 0; j < C; j++)
		{
			if(riadok[j]=='X') mapa[i][j]=STENA;
			else {
				mapa[i][j]=VOLNO;
				if(riadok[j]=='S')
				{
					printf("spawn %d %d\n", i, j);
					spawny.push_back(i);
					spawnx.push_back(j);
				}
				if(riadok[j]=='A')
				{
					printf("ammo %d %d\n", i, j);
					ammoy.push_back(i);
					ammox.push_back(j);
				}
			}
		}
	}
	fclose(file);
	//spawny.push_back(2);
	//spawnx.push_back(2);
	//spawny.push_back(4);
	//spawnx.push_back(2);
	/*for(int i = 0; i < R; i++)
	{
		mapa[i][0]=STENA;
		mapa[i][C-1]=STENA;
	}
	for(int i = 0; i < C; i++)
	{
		mapa[0][i]=STENA;
		mapa[R-1][i]=STENA;
	}
	spawny.push_back(10);
	spawnx.push_back(10);
	spawny.push_back(10);
	spawnx.push_back(12);*/
}

bool IsVisible(double b, double e, set<double> &begins, set<double> &ends)
{
	int hlb = 0;
	set<double>::iterator i[2];
	i[0] = begins.begin();
	i[1] = ends.begin();
	
	for(; i[0]!=begins.end() && (*i[0])<=b; i[0]++) hlb++;
	for(; i[1]!=ends.end() && (*i[1])<=b; i[1]++) hlb--;
	int ch;
	if(hlb == 0) return true;
	//bool fail = true;
	while(1)
	{
		if(i[1]==ends.end())break;
		if(i[0]==begins.end()) ch = 1;
		else if((*i[0])<(*i[1])) ch = 0;
		else ch = 1;
		if(*i[ch]>e){
			return false;
		}
		i[ch]++;
		if(ch==0) hlb++;
		else hlb--;
		if(hlb == 0) return true;
	}
	return true;
}

void Mapa::GetVisiblePart(int y, int x, int rot, GameData &data)
{
	for(int i = 0; i < (int)mapa.size(); i++){
//		printf("%d\n", i);
		for(int j = 0; j < (int)mapa[i].size(); j++){
//			printf("  %d\n", j);
			data.mapa[i][j]=-2;}
	}
//	printf("vyprazdnene\n");
	queue<pair<int,int> >fronta;
	for(int i = 0; i < 4; i++)
	{
		fronta.push(pair<int,int>(y+sy[i],x+sx[i]));
	}
	data.mapa[y][x] = VOLNO;
	pair<int,int> flek;
	int nx, ny;
	set<double> begins;
	set<double> ends;
	double cos;
	double s[4];
	double b, e;
	while(!fronta.empty())
	{
		flek = fronta.front();
		//printf("%d %d\n", flek.first, flek.second);
		fronta.pop();
		data.mapa[flek.first][flek.second]=UNKNOWN;
		cos = CosUhla(smerx[rot],smery[rot],flek.second-x, flek.first-y);
		for(int i = 0; i < 4; i++)
		{
			s[i] = SinUhla(smerx[rot],smery[rot],flek.second+px[i]-x,flek.first+py[i]-y);
		}
		b = min(min(s[0],s[1]),min(s[2],s[3]));
		e = max(max(s[0],s[1]),max(s[2],s[3]));
		if(cos<0.707) continue;
		if(!IsVisible(b, e, begins, ends)) continue;
		if(mapa[flek.first][flek.second]==STENA){ 
			data.mapa[flek.first][flek.second] = STENA; 
			begins.insert(b);
			ends.insert(e);
			continue; 
		}
		data.mapa[flek.first][flek.second] = VOLNO;
		for(int i = 0; i < 4; i++)
		{
			nx = flek.second+sx[i];
			ny = flek.first+sy[i];
			if(data.mapa[ny][nx]!=-2) continue;
			data.mapa[ny][nx]=UNKNOWN;
			fronta.push(pair<int,int>(ny, nx));
		}
	}
	for(int i = 0; i < (int)mapa.size(); i++){
//		printf("%d\n", i);
		for(int j = 0; j < (int)mapa[i].size(); j++){
//			printf("  %d\n", j);
			if(data.mapa[i][j]==-2) data.mapa[i][j]=UNKNOWN;}
	}
	//printf("fin\n");
}