#ifndef __NETWORK_H__
#define __NETWORK_H__

#include <string>
#include <queue>

#ifdef WIN32
	#undef interface
	#define interface TOTALNY_KALERAB_EXCLAMATION_MARK
#endif

struct Packet 
{
	int len;
	//int type;
	void *payload;
};

class Connection
{
	private:
		int fd;
		int async_recv_len;

	public:
		Connection(int fd);
		Connection();
		virtual ~Connection();

		int connect(std::string host, int port=1234);
		int send(Packet& packet);
		Packet receive();
		int receive_async(Packet& packet);
		bool good();
	private:
		int recv_error(const char *fun, int line);
		int send_error(const char *fun, int line);
};

class NetworkServer 
{
	private:
		int fd;
#ifdef WIN32
		std::queue<int> accept_queue;
#endif
	public:
		NetworkServer();
		void init(std::string interface="0.0.0.0", int port=1234);
		virtual ~NetworkServer();

		bool connection_pending();
		Connection *accept_connection();
};

#endif

