#ifndef MISSILE_H
#define MISSILE_H

struct AreaDamage
{
	int x, y;
	int dmg;
	AreaDamage(int xx, int yy, int d){x=xx; y=yy; dmg=d;}
};

class Player;

class Missile
{
public:
	static int nmis;
	int y, x;
	int rot;
	int movex, movey;
	int damage;
	int speed;
	bool alive;
	bool dieonhit;
	int id;
	int type;
	Player *owner;
	Missile() {id=nmis; nmis++;};
	virtual int GetDirectDmg()
	{
		return damage;
	}
	virtual void GetAreaDmg(vector<AreaDamage>&dmg){};
	virtual pair<int,int> GetVel() {return pair<int,int>(msmery[rot]*speed, msmerx[rot]*speed);}
	virtual bool Tick()
	{
		x+=movex;
		y+=movey;
		return !alive;
	}
};

class PistolAmmo : public Missile
{
public:
	PistolAmmo(){ damage=PISTOLDMG; speed=PISTOLMISSILESPEED; alive=true; dieonhit=true; id=nmis; nmis++; type=PISTOL;}
	PistolAmmo(int yy, int xx, int rrot, Player*oowner){y=yy; x=xx; rot=rrot; damage=PISTOLDMG; speed=PISTOLMISSILESPEED; owner=oowner; alive=true; dieonhit=true; id=nmis; nmis++; type=PISTOL;}
};

class Brok : public Missile
{
public:
	Brok(){ damage=BROKDMG; speed=BROKMISSILESPEED; alive=true; dieonhit=true; id=nmis; nmis++; type=BROKOVNICA;}
	Brok(int yy, int xx, int rrot, Player*oowner){y=yy; x=xx; rot=rrot; damage=BROKDMG; speed=BROKMISSILESPEED; owner=oowner; alive=true; dieonhit=true; id=nmis; nmis++; type=BROKOVNICA;}
};

class Rocket : public Missile
{
public:
	Rocket() {speed=BAZOOKASPEED; damage=0; dieonhit=false; id=nmis; nmis++; type=BAZOOKA;}
	Rocket(int yy, int xx, int rrot, Player*oowner){y=yy; x=xx; rot=rrot; damage=0; speed=BAZOOKASPEED; owner=oowner; alive=true; dieonhit=true; id=nmis; nmis++; type=BAZOOKA;}
	virtual void GetAreaDmg(vector<AreaDamage>&dmg)
	{
		dmg.push_back(AreaDamage(0,0,BAZOOKAINNERDMG));
		for(int i = 0; i < 4; i++)
			dmg.push_back(AreaDamage(sx[i], sy[i], BAZOOKAOUTERDMG));
	}
	virtual pair<int,int> GetVel()
	{
		return pair<int,int>(msmery[rot]*speed, msmerx[rot]*speed);
		//return pair<int,int>(0,0);
	}
};

class KRocket : public Missile
{
public:
	KRocket() {speed=KATUSASPEED; damage=0; dieonhit=false; id=nmis; nmis++; type=KATUSA;}
	KRocket(int yy, int xx, int rrot, Player*oowner){y=yy; x=xx; rot=rrot; damage=0; speed=KATUSASPEED; owner=oowner; alive=true; dieonhit=true; id=nmis; nmis++; type=KATUSA;}
	virtual void GetAreaDmg(vector<AreaDamage>&dmg)
	{
		dmg.push_back(AreaDamage(0,0,KATUSAINNERDMG));
		for(int i = 0; i < 4; i++)
			dmg.push_back(AreaDamage(sx[i], sy[i], KATUSAOUTERDMG));
	}
	virtual pair<int,int> GetVel()
	{
		return pair<int,int>(msmery[rot]*speed, msmerx[rot]*speed);
		//return pair<int,int>(0,0);
	}
};


/*class Grenade : public Missile
{
public:
	int timetoexp;
	Grenade() {timetoexp=GRENADEEXPTIME; speed=GRENADESPEED; damage=0; dieonhit=false; id=nmis; nmis++; type=GRENADE;}
	Grenade(int yy, int xx, int rrot, Player*oowner){y=yy; x=xx; rot=rrot; damage=0; speed=GRENADESPEED; owner=oowner; alive=true; dieonhit=false; timetoexp=GRENADEEXPTIME; id=nmis; nmis++; type=GRENADE;}
	virtual void GetAreaDmg(vector<AreaDamage>&dmg)
	{
		dmg.push_back(AreaDamage(0,0,GRENADEINNERDMG));
		for(int i = 0; i < 4; i++)
			dmg.push_back(AreaDamage(sx[i], sy[i], GRENADEOUTERDMG));
	}
	virtual pair<int,int> GetVel()
	{
		return pair<int,int>(msmery[rot]*speed, msmerx[rot]*speed);
		//return pair<int,int>(0,0);
	}
	virtual bool Tick()
	{
		x+=movex;
		y+=movey;
		timetoexp--;
		if(timetoexp==0){ alive=false; return true;}
		return false;
	}
};*/

#endif