#include "headers.h"


//veci, co dava configurak

int NPLAYERS=1;
int NDRAWERS=1;
int port=4742;
int drawport=4747;
int spawnammo=10;		//v percentach
int maxammo=10;
int gametime=10;

//---------------------------------------------

Logger logger;
vector<Player*> players;
Mapa mapa;
int ROWS=20, COLS=47;

vector<int> poradie;

vector<Missile*> missiles;
vector<Missile*> tempmissiles;

map<pair<int,int>, int> ammo;

NetworkServer server;
NetworkServer drawserver;

vector<Connection*> drawers;

int starttime;

int Missile::nmis = 0;

//Mix_Chunk *phaser = NULL;

Mix_Chunk** SoundManager::chunks = NULL;

int LoadConfig() {
	Preferences::createInstance();
	Preferences::_loadFromFile("server.cfg");

	NPLAYERS = Preferences::_getDefaultInt("nplayers", 4);
	NDRAWERS = Preferences::_getDefaultInt("ndrawers", 4);
	port = Preferences::_getDefaultInt("port", 4742);
	drawport = Preferences::_getDefaultInt("drawport", 4747);
	gametime = Preferences::_getDefaultInt("gametime", 10);
	return 1;
}

void LoadPlayers() {
	logger.Output(MESSAGE, "Starting server");
	server.init("0.0.0.0", port);
	while((int)players.size() < NPLAYERS)
	{
		usleep(PLAYER_WAIT_SLEEP_TIME*1000);
		if(server.connection_pending())
		{
			players.push_back(new Player);
			players[players.size()-1]->conn = server.accept_connection();
			players[players.size()-1]->SendInitData();
			players[players.size()-1]->Spawn();
			players[players.size()-1]->RecInitData();
			logger.Output(MESSAGE, "Hrac sa pripojil");
		}
	}
	for(int i = 0; i < NPLAYERS; i++)
		poradie.push_back(i);
}

void Reconnect()
{
	Player temp;
	temp.conn = server.accept_connection();
	temp.SendInitData();
	temp.RecInitData();
	for(int i = 0; i < (int)players.size(); i++)
	{
		if(strcmp(players[i]->nick, temp.nick)==0)
		{
			delete players[i]->conn;
			players[i]->conn = temp.conn;
			logger.Output(MESSAGE, "Reconnect");
			players[i]->waiting = false;
		}
	}
}

/*void SendMap(int drawer)
{
	Packet packet;
	MapaSend m;
	m.r = ROWS;
	m.c = COLS;
	for(int i = 0; i < m.r; i++)
		for(int j = 0; j < m.c; j++)
			m.mapa[i][j] = mapa.mapa[i][j];
	m.nplayers = NPLAYERS;
	
	packet.payload = &m;
	packet.len = sizeof(m);
	drawers[drawer]->send(packet);
}*/

void LoadDrawers()
{
	Packet packet;
	MapaSend m;
	m.r = ROWS;
	m.c = COLS;
	for(int i = 0; i < m.r; i++)
		for(int j = 0; j < m.c; j++)
			m.mapa[i][j] = mapa.mapa[i][j];
	m.nplayers = NPLAYERS;
	for(int i = 0; i < NPLAYERS; i++)
		strcpy(m.nicks[i], players[i]->nick);
	packet.payload = &m;
	packet.len = sizeof(m);

	drawserver.init("0.0.0.0", drawport);
	while((int)drawers.size() < NDRAWERS)
	{
		usleep(DRAWER_WAIT_SLEEP_TIME*1000);
		if(drawserver.connection_pending())
		{
			logger.Output(MESSAGE, "Drawer sa pripojil");
			drawers.push_back(drawserver.accept_connection());
			//SendMap(drawers.size()-1);
			drawers[drawers.size()-1]->send(packet);
		}
	}
}

void InitSound()
{
	

}

int Init() {
	logger.Output(MESSAGE, "Init start");
	srand(time(NULL));
	if(LoadConfig()==0) return 0;
	mapa.Generate(ROWS, COLS, rand());
	logger.Output(MESSAGE, "Mapa vygenerovana");
	//InitSound();
	SoundManager::Init();
	LoadPlayers();
	LoadDrawers();
	starttime = time(NULL);
	SoundManager::PlaySound(9);
	usleep(2000000);
	return 1;
}

void Draw() {
	bool b;
	for(int i = 0; i < ROWS; i++)
	{
		for(int j = 0; j < COLS; j++)
		{
			if(mapa.mapa[i][j]==1)
				printf("X");
			else
			{
				b = false;
				for(int k = 0; k < (int)players.size(); k++)
					if(players[k]->y == i && players[k]->x == j){ b = true;
						printf("%d", k);}
				for(int k = 0; k < (int)players.size(); k++)
					if(players[k]->y+smery[players[k]->rot]==i && players[k]->x+smerx[players[k]->rot]==j){ b= true;
						printf("*");}
				if(!b)
				{
					for(int k = 0; k < (int)missiles.size(); k++)
						if(missiles[k]->y == i && missiles[k]->x == j){ b = true;
							printf("S");}
				}
				if(!b)
					if(ammo.count(pair<int,int>(i,j))!=0){b = true; printf("A");}
				if(!b) printf(".");
			}
		}
		printf("\n");
	}
	printf("pocet striel %d\n", missiles.size());
	for(int i = 0; i < (int)missiles.size(); i++)
		printf("%d: y: %d %x: d\n", i, missiles[i]->y, missiles[i]->x);
	for(int i = 0; i < (int)players.size(); i++)
		printf("%s: hp: %d f/d: skore: %d/%d zbran: %d naboje: %d/%d\n", players[i]->nick, players[i]->hp, players[i]->frags, players[i]->deaths,players[i]->curweapon,players[i]->weapons[players[i]->curweapon]->zasobnik,players[i]->weapons[players[i]->curweapon]->zbytok);
	//printf("ammo %d\n", ammo.size());

	DrawSend send;
	send.nObjects = 0;
	Packet packet;
	for(int i = 0; i < (int)players.size(); i++)
	{
		send.objects[send.nObjects].type = OBJECT_PLAYER;
		send.objects[send.nObjects].x = players[i]->x;
		send.objects[send.nObjects].y = players[i]->y;
		send.objects[send.nObjects].rotate = players[i]->rot;
		send.objects[send.nObjects].id = players[i]->weapons[players[i]->curweapon]->zbytok*MAX_HP*MAX_ZASOBNIK*5+players[i]->weapons[players[i]->curweapon]->zasobnik*MAX_HP*5+players[i]->hp*5+players[i]->curweapon;
		send.objects[send.nObjects].spawned = players[i]->spawned;
		send.nObjects++;
		send.stats[i][0]=players[i]->frags;
		send.stats[i][1]=players[i]->deaths;
	}
	for(map<pair<int,int>, int>::iterator it = ammo.begin(); it!=ammo.end(); it++)
	{
		send.objects[send.nObjects].type = OBJECT_AMMO+(*it).second;
		send.objects[send.nObjects].x = (*it).first.second;
		send.objects[send.nObjects].y = (*it).first.first;
		send.objects[send.nObjects].spawned = true;
		send.nObjects++;
	}
	for(int i = 0; i < (int)missiles.size(); i++)
	{
		//if(data.mapa[missiles[i]->y][missiles[i]->x]==UNKNOWN) continue;
		send.objects[send.nObjects].type = OBJECT_MISSILE+missiles[i]->type+100*missiles[i]->speed;
		send.objects[send.nObjects].x = missiles[i]->x;
		send.objects[send.nObjects].y = missiles[i]->y;
		send.objects[send.nObjects].rotate = missiles[i]->rot;
		send.objects[send.nObjects].id = missiles[i]->id+MAX_PLAYERS;
		send.objects[send.nObjects].spawned = missiles[i]->alive;
		send.nObjects++;
	}
	packet.len = sizeof(send);
	packet.payload = &send;
	for(int i = 0; i < (int)drawers.size(); i++)
	{
		drawers[i]->send(packet);
	}
}

void ParseMoves(const vector<Action> &act)
{
	//printf("pm\n");
	random_shuffle(poradie.begin(), poradie.end());
	//printf("shuff\n");
	int nx, ny;
	for(int i = 0; i < (int)players.size(); i++)
	{
		players[poradie[i]]->movex = 0;
		players[poradie[i]]->movey = 0;
	}
	//printf("vynul\n");
	bool p;
	for(int i = 0; i < (int)players.size(); i++)
	{
		//printf("i %d %d\n", i, poradie[i]);
		if(abs(act[poradie[i]].mx)+abs(act[poradie[i]].my)<=1 && abs(act[poradie[i]].my)< 2 && abs(act[poradie[i]].my)<2){
			//printf("  in %d %d %d %d\n", act[poradie[i]].mx, act[poradie[i]].my, abs(act[poradie[i]].mx), abs(act[poradie[i]].my));
			nx = players[poradie[i]]->x+act[poradie[i]].mx;
			ny = players[poradie[i]]->y+act[poradie[i]].my;
			//printf(" n %d %d\n", ny, nx);
			if(mapa.mapa[ny][nx]==STENA) continue;
			p = true;
			for(int j = 0; j < (int)players.size(); j++)
			{
				if(poradie[i]==j) continue;
				if(players[j]->x+players[j]->movex==nx && players[j]->y+players[j]->movey==ny) p = false;
			}
			if(!p) continue;
			players[poradie[i]]->movex = act[poradie[i]].mx;
			players[poradie[i]]->movey = act[poradie[i]].my;
		}
	}
}

//y,x,movex,movey - pozicia+pohyb hraca
//mis,vel - pozicia+pohyb strely
//pol/all - v ktorej casti drahy strela je
inline bool WasHitted(const int &y, const int &x, const int &movey, const int &movex, const int &misy, const int &misx, const int&sty, const int&stx, const int &vely, const int &velx, const int &pol, const int &all)
{
	bool pohyb=false;
	bool hit1=false, hit2=false;
	bool smer=false;
	bool lajn=false;

	if(y==misy&&x==misx) hit1=true;
	if(y+movey==misy&&x+movex==misx)hit2=true;
	if(hit1==false && hit2==false) return false;
	
	int sanca=100;

	if(movey!=0||movex!=0) pohyb=true;
	if((movey*velx-movex*vely)==0) smer=true;
	if(vely==0 || velx==0 || pol%3==0) lajn=true;
	if((pohyb==false)||(smer&&lajn)) sanca=99;
	else sanca=50;
	
	int cis = rand()%100;
	if(cis<sanca) return true;
	//if(y==misy && x==misx) return true;
	return false;
} 

void ParseHits()
{
	static bool fb = true;
	pair<int,int> vel;
	bool h;
	for(int i = 0; i < (int)missiles.size(); i++)
	{
		//printf("%d\n", i);
		vel = missiles[i]->GetVel();
		vector<pair<int,int> > hits;
		//printf("%d %d %d %d\n", missiles[i]->y, missiles[i]->x, vel.first, vel.second);
		GetHitedFields(missiles[i]->y, missiles[i]->x, vel.first, vel.second, hits);
		missiles[i]->movey = vel.first;
		missiles[i]->movex = vel.second;
		//printf("hitted %d\n", (int)hits.size());
		for(int j = 1; j < (int)hits.size(); j++)
		{
			//printf("j:%d %d %d\n",j, hits[j].first, hits[j].second);
			if(mapa.mapa[hits[j].first][hits[j].second]==STENA)
			{
				if(missiles[i]->dieonhit)
					missiles[i]->alive = false;
				missiles[i]->movey = hits[j-1].first-missiles[i]->y;
				missiles[i]->movex = hits[j-1].second-missiles[i]->x;
				//printf("c: %d %d %d %d %d %d\n", missiles[i]->movey, missiles[i]->movex, hits[j].first, hits[j].second, missiles[i]->y, missiles[i]->x);
				break;
			}
			h = false;
			for(int k = 0; k < (int)players.size(); k++)
			{
				if(players[k]->spawned) continue;
				if(missiles[i]->owner==players[k]) continue;
				//if(players[k]->x == hits[j].second && players[k]->y == hits[j].first)
				if(WasHitted(players[k]->y, players[k]->x, players[k]->movey, players[k]->movex, hits[j].first, hits[j].second, missiles[i]->y, missiles[i]->x, vel.first, vel.second, j, hits.size()))
				{
					h = true;
					players[k]->hp -= missiles[i]->GetDirectDmg();
					if(players[k]->hp <= 0)
					{
						printf("Frag!\n");
						SoundManager::PlaySound(6+rand()%3);
						players[k]->deaths++;
						players[k]->spree=0;
						if(missiles[i]->owner != players[k])
						{
							//missiles[i]->owner->frags++;
							missiles[i]->owner->AddFrag();
							if(fb){
								SoundManager::PlaySound(10);
								fb = false;
							}
						}
						else{
							missiles[i]->owner->frags--;}
						players[k]->Spawn();
					}
					break;
				}
			}
			if(h){
				missiles[i]->speed=0;
				missiles[i]->movey = hits[j].first-missiles[i]->y;
				missiles[i]->movex = hits[j].second-missiles[i]->x;
//				printf("b: %d %d %d %d %d %d\n", missiles[i]->movey, missiles[i]->movex, hits[j].first, hits[j].second, missiles[i]->y, missiles[i]->x);
				if(missiles[i]->dieonhit)
					missiles[i]->alive = false;
				break;
			}
		}
		//printf("end\n");
		if(missiles[i]->Tick())
		{
	//		printf("bang %d %d\n", missiles[i]->y, missiles[i]->x);
			vector<AreaDamage> dmg;
			missiles[i]->GetAreaDmg(dmg);
			for(int j = 0; j < (int)players.size(); j++)
				players[j]->tempdmg = 0;
			if(dmg.size()>0)
			{
				SoundManager::PlaySound(5);
			}
			for(int j = 0; j < (int)dmg.size(); j++)
			{
		//		printf("banghit %d %d %d\n", missiles[i]->y+dmg[j].y,missiles[i]->x+dmg[j].x, dmg[j].dmg);
				for(int k = 0; k < (int)players.size(); k++)
				{
					if(players[k]->spawned) continue;
					if((players[k]->x == missiles[i]->x+dmg[j].x) && (players[k]->y == missiles[i]->y+dmg[j].y))
					{
						//printf("dmg %d %d\n", players[k]->y, players[k]->x);
						players[k]->tempdmg += dmg[j].dmg;
					}
					if((players[k]->x+players[k]->movex == missiles[i]->x+dmg[j].x) && (players[k]->y+players[k]->movey == missiles[i]->y+dmg[j].y))
					{
						//printf("dmg2 %d %d\n", players[k]->y+players[k]->movey, players[k]->x+players[k]->movex);
						players[k]->tempdmg += dmg[j].dmg;
					}
				}
			}
			for(int j = 0; j < (int)players.size(); j++)
			{
				//printf("tdmg %d\n", players[j]->tempdmg);
				if(players[j]->spawned) continue;
				players[j]->hp -= players[j]->tempdmg/2;
				if(players[j]->hp <= 0)
				{
					printf("Frag 2!\n");
					players[j]->deaths++;
					players[j]->spree=0;
					SoundManager::PlaySound(6+rand()%3);
					if(missiles[i]->owner != players[j])
					{
						//missiles[i]->owner->frags++;
						missiles[i]->owner->AddFrag();
						if(fb){
							SoundManager::PlaySound(10);
							fb = false;
						}
					}
					else{
						missiles[i]->owner->frags--;}
					players[j]->Spawn();
				}
			}
		}
	}
}

void ParseShots(const vector<Action> &act)
{
	bool tras;
	for(int i = 0; i < (int)act.size(); i++)
	{
		if(players[i]->spawned) continue;
		tras = false;
		if(act[i].weaponaction==SHOT)
		{
			if(act[i].mx!=0||act[i].my!=0||abs(act[i].rotate)>1) tras = true;
			if(players[i]->weapons[players[i]->curweapon]->Shot(missiles, players[i]->y, players[i]->x, players[i]->rot,tras)){
				printf("shot\n");
			}
		}
		if(act[i].weaponaction==RELOAD)
		{
			players[i]->weapons[players[i]->curweapon]->Reload();
		}
		if(act[i].weaponaction>=CHANGE_WEAPON)
		{
			if(act[i].weaponaction-CHANGE_WEAPON<(int)players[i]->weapons.size())
				players[i]->curweapon = act[i].weaponaction-CHANGE_WEAPON;
		}
		players[i]->weapons[players[i]->curweapon]->Tick();
	}
}

void Uprataj()
{
	tempmissiles.clear();
	for(int i = 0; i < (int)missiles.size(); i++)
	{
		if(missiles[i]->alive) tempmissiles.push_back(missiles[i]);
		else delete missiles[i];
	}
	swap(tempmissiles, missiles);
}

void AddAmmo()
{
	if((int)ammo.size()<maxammo)
	{
		//int a = rand()%(players[0]->weapons.size());
		int a=0;
		int tmp=0;
		int r = rand()%CHANCESSUM;
		for(int i = 0; i < NWEAPONS; i++)
		{
			if(r < tmp+ammochances[i]){ a=i; break;}
			tmp +=ammochances[i];
		}
		int x, y;
		bool b;
		vector<int> sp;
		for(int i = 0; i < (int)mapa.ammox.size(); i++)
		{
			x = mapa.ammox[i];
			y = mapa.ammoy[i];
			b = true;
			for(int j = 0; j < NPLAYERS; j++)
				if(players[j]->x == x && players[j]->y == y) b = false;
			if(ammo.count(pair<int,int>(y,x))!=0)
				b = false;
			if(b) sp.push_back(i);
		}
		r = sp[rand()%sp.size()];
		ammo[pair<int,int>(mapa.ammoy[r],mapa.ammox[r])]=a;
	}
}

int Step() {
	static long long last=0;
	
	//system("clear");
	int curtime = time(NULL);
	if(curtime > starttime+gametime)
	{
		logger.Output(MESSAGE, "The end");
		for(int i = 0; i < (int)players.size(); i++)
			players[i]->SendEnd();
		DrawSend dr;
		dr.nObjects = -1;
		Packet p; p.len = sizeof(dr);
		p.payload = &dr;
		for(int i = 0; i < (int)drawers.size(); i++)
			drawers[i]->send(p);
		usleep(10000000);
		return 0;
	}
	Draw();
	
	Uprataj();

	logger.Output(MESSAGE, "Draw");
	for(int i = 0; i < (int)players.size(); i++)
		players[i]->SendPlayerData();
	for(int i = 0; i < (int)players.size(); i++)
		players[i]->DeSpawn();

	logger.Output(MESSAGE, "DataSend");

	timeval tv;
	gettimeofday(&tv, NULL);
	long long dif = 1000000*tv.tv_sec+tv.tv_usec-last;
	printf("roundtime %Ld\n", dif);
	if(last==0) dif=0;
	usleep(max((long long)200*1000,ROUND_SLEEP_TIME*1000-dif));
	
	gettimeofday(&tv, NULL);
	last = 1000000*tv.tv_sec+tv.tv_usec;


	vector<Action> act;
	act.resize(players.size());
	
	for(int i = 0; i < (int)players.size(); i++) {
		if(players[i]->ReceivePlayerData(act[i])) {
			if(act[i].rotate < -MAX_ROT) act[i].rotate=-2;
			if(act[i].rotate > MAX_ROT) act[i].rotate=2;
		}
	}
	for(int i = 0; i < (int)players.size(); i++)
		players[i]->Rotate(act[i].rotate);
	logger.Output(MESSAGE, "Data rec");
	ParseMoves(act);
	logger.Output(MESSAGE, "Moves");
	ParseHits();
	logger.Output(MESSAGE, "Hits");
	ParseShots(act);
	logger.Output(MESSAGE, "Shot");
	for(int i = 0; i < (int)players.size(); i++)
	{
		players[i]->Move();
		pair<int,int> p(players[i]->y,players[i]->x);
		if(ammo.count(p)!=0)
		{
			players[i]->weapons[ammo[p]]->AddAmmo();
			ammo.erase(p);
		}
		//players[i]->Rotate(act[i].rotate);
	}
	logger.Output(MESSAGE, "Move");
	logger.Output(MESSAGE, "Clean");
	int i = rand()%100;
	if(i < spawnammo)
	{
		AddAmmo();
	}
	logger.Output(MESSAGE, "Fin");
	if(server.connection_pending())
	{
		Reconnect();
	}
	return 1;
}

void DeAlloc() {
	
}

int main() {
	logger.SetWarnLevel(MESSAGE);
	if(Init()==0) {
		logger.Output(ERROR, "Init failed");
		return 0;
	}
	logger.Output(MESSAGE, "Init finished");
	while(1) {
		if(Step()==0) break;
	}
	DeAlloc();
	return 0;
}
