#ifndef SOUNDS_H
#define SOUNDS_H

const char soundfiles[][100] = {"pistol.wav", "brok.wav", "bazooka.wav", "katusa.wav", "uzi.wav", "explosion.wav", "die1.wav", "die2.wav", "die3.wav", "go.wav", "fb.wav", "k3.wav", "k4.wav", "k5.wav", "k6.wav", "k7.wav", "k8.wav", "k9.wav", "k10.wav"};
const int nsounds=19;

class SoundManager
{
public:
	SoundManager() {};
	static Mix_Chunk** chunks;
	static void Init(){
		int audio_rate = 22050;
		Uint16 audio_format = AUDIO_S16; 
		int audio_channels = 2;
		int audio_buffers = 4096;
		SDL_Init(SDL_INIT_AUDIO);
		if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers)) {
			printf("Unable to open audio!\n");
			exit(1);
		}
		chunks = new Mix_Chunk*[nsounds];
		for(int i = 0; i < nsounds; i++)
			chunks[i] = Mix_LoadWAV(soundfiles[i]);
	}
	static void PlaySound(int sound)
	{
		Mix_PlayChannel(-1, chunks[sound] , 0);
	}
};

#endif