#include "headers.h"
#include <math.h>

#define startammo startammmo

int RIADKY, STLPCE;

char nick[]="tomiINTJ";

int rozteky[MAX_ROZMER][MAX_ROZMER];
int zlespomienky[MAX_ROZMER][MAX_ROZMER];
int dobrespomienky[MAX_ROZMER][MAX_ROZMER];
int chcemeammo[MAX_ROZMER][MAX_ROZMER];
int videl_ammo[MAX_ROZMER][MAX_ROZMER];

int poznam[MAX_ROZMER][MAX_ROZMER];

int previousx[MAX_ROZMER][MAX_ROZMER];
int previousy[MAX_ROZMER][MAX_ROZMER];
int distances[MAX_ROZMER][MAX_ROZMER];
int visited[MAX_ROZMER][MAX_ROZMER];

int zbrane[5][7] = {
  {PISTOLMISSILESPEED, PISTOLSHOTTIME, PISTOLRELOADTIME, PISTOLZASOBNIK, PISTOLAMMOSIZE, PISTOLDMG, 0},
  {BROKMISSILESPEED, BROKSHOTTIME, BROKRELOADTIME, BROKZASOBNIK, BROKAMMOSIZE, BROKDMG, 0},
  {UZIMISSILESPEED, UZISHOTTIME, UZIRELOADTIME, UZIZASOBNIK, UZIAMMOSIZE, UZIDMG, 0},
  {BAZOOKASPEED, BAZOOKASHOTTIME, BAZOOKARELOADTIME, BAZOOKAZASOBNIK, BAZOOKAAMMOSIZE, BAZOOKAINNERDMG, BAZOOKAOUTERDMG},
  {KATUSASPEED, KATUSASHOTTIME, KATUSARELOADTIME, KATUSAZASOBNIK, KATUSAAMMOSIZE, KATUSAINNERDMG, KATUSAOUTERDMG},
};

int mojHP, mojX, mojY;

int strielaliMa;
int chcemReloadovat;
int stopBoj;

int dalekox, dalekoy;

#define ROZ_ROZTEK         45
#define ROZ_NEPRESKUMANE   70

#define DOBRE_ZOTRVACNOST  40
#define DOBRE_STRELIL      5
#define DOBRE_AMMO         25

#define DOBRE_CHCEMEAMMO   7 /* resp. DOBRE_CHCEMEAMMO*x, nie len DOBRE_CHCEMEAMMO */

#define ZLE_NERAD_CESTUJEM 2
#define ZLE_BOLO_OK        -1
#define ZLE_ZABILI_MA      60
#define ZLE_STRELILI_MA    10

#define ZLE_BLUR           0.7

int zAbs(int m) {
  return m < 0 ? -m : m;
}

int Pozri(int x, int y) {
  if(x < 0 || y < 0 || x >= STLPCE || y >= RIADKY) return STENA;
  return poznam[y][x];
}

int GetFieldRisk(const GameData &data, int x, int y, int smer) {
  int i;
  for(i = 0; i < data.nObjects; i++)
    if(data.objects[i].type == OBJECT_PLAYER &&
       data.objects[i].x == x && data.objects[i].y == y)
      return 30;
  int m = Pozri(x, y);
  if(m == UNKNOWN) return 14;
  if(m == STENA) return 0;
  int qq = smer - data.rotate;
  while(qq < -4) qq += 16;
  if(data.mapa[m] == VOLNO || zAbs(qq) < 2) return 1;
  return 3;
}

int GetRisk(const GameData &data, int smer) {
  int smerZ = smer;
  while(smer >= 16) smer -= 16;
  smer /= 2;
  // od 0: vpravo, vpdole, dole, vldole, vlavo, vlhore, hore, vphore
  int risk = 0;
  if(smer % 2 == 0) {
    for(int oy = 0; oy < 5; oy++)
      for(int ox = -oy; ox <= oy; ox++) {
        int rx = ox, ry = oy, tmp;
        if(smer == 6 || smer == 4) ry *= -1;
        if(smer == 0 || smer == 4) { tmp = ry; ry = rx; rx = tmp; }
        risk += GetFieldRisk(data, data.x + rx, data.y + ry, smerZ);
      }
  }
  else {
    for(int ox = 0; ox < 6; ox++)
      for(int oy = 0; oy < 6; oy++)
        if(ox + oy < 7 && (ox || oy)) {
          int rx = ox, ry = oy;
          if(smer == 7 || smer == 5) ry *= -1;
          if(smer == 3 || smer == 5) rx *= -1;
          risk += GetFieldRisk(data, data.x + rx, data.y + ry, smerZ);
        }
  }
  if(strielaliMa && !stopBoj && zAbs(smerZ-data.rotate) > 2) risk = 2*risk + 2;
//  printf("smer %d risk %d\n", smerZ, risk);
  return risk;
}

// najdeme najkratsiu cestu co sa vyhne geopatogennym zonam (zlym spomienkam)
void Dijkstra(const GameData &data)
{
  int curx=data.x, cury=data.y, x, y;
  for(y = 0; y < MAX_ROZMER; y++) {
    for(x = 0; x < MAX_ROZMER; x++) {
      distances[y][x] = 60000;
      previousx[y][x] = curx; previousy[y][x] = cury;
      visited[y][x] = 0;
    }
  }
  int i;
  distances[cury][curx] = zlespomienky[cury][curx];
  while(1) {
    visited[cury][curx] = 1;
    for(i = 0; i < 4; i++) {  // preskumame susedov
      int susedx = sx[i]+curx, susedy = sy[i]+cury;
      if(susedx < 0 || susedy < 0 || susedx >= STLPCE || susedy >= RIADKY) continue;
      if(poznam[susedy][susedx] == STENA || visited[susedy][susedx]) continue;
      int novydist = distances[cury][curx] + zlespomienky[susedy][susedx];
      if(novydist < distances[susedy][susedx]) {
        distances[susedy][susedx] = novydist;
        previousx[susedy][susedx] = curx;
        previousy[susedy][susedx] = cury;
      }
    }
    cury = -1; curx = -1;
    for(y = 0; y < RIADKY; y++) {   // toto by slo zefektivnit
      for(x = 0; x < STLPCE; x++) {
        if(visited[y][x]) continue;
        if(cury == -1 || distances[y][x] < distances[cury][curx]) cury=y,curx=x;
      }
    }
    if(cury == -1) break;
  }
}

void Initialize()
{
  srand(time(NULL) * getpid());
  int i, j;
  for(i = 0; i < MAX_ROZMER; i++) {
    for(j = 0; j < MAX_ROZMER; j++) {
      poznam[i][j] = UNKNOWN;
      dobrespomienky[i][j] = chcemeammo[i][j] = videl_ammo[i][j] = 0;
      rozteky[i][j] = ROZ_NEPRESKUMANE;
      zlespomienky[i][j] = ZLE_NERAD_CESTUJEM;
    }
  }
  mojHP = 100;
  mojX = mojY = 0;
  dalekox = dalekoy = -1;
  chcemReloadovat = 0;
  stopBoj = 0;
}

void Finalize()
{
}

Action Step(const GameData &data)
{
  Action ret;

  strielaliMa = 0;
  
  int bojujeme = -1;
  int targetRot = -1;
  int targx, targy;
  int x,y;
  
  ret.rotate = 0;
  
  if(zlespomienky[data.y][data.x] > 1)
    zlespomienky[data.y][data.x] += ZLE_BOLO_OK;
  
  int objavil = 0;

  if((mojX != data.x || mojY != data.y) && !data.spawned) {
    // nemohol som sa tam pohnut... preco? zeby tam bola stena? (ak nie, neskor to fixneme.)
    if(poznam[mojY][mojX] == UNKNOWN)
      poznam[mojY][mojX] = STENA, rozteky[mojY][mojX] -= ROZ_NEPRESKUMANE, objavil = 1;
    mojX = data.x; mojY = data.y;
  }
  
  if(poznam[data.y][data.x] == UNKNOWN)
    poznam[data.y][data.x] = VOLNO, rozteky[data.y][data.x] -= ROZ_NEPRESKUMANE, objavil = 1;
  
  for(y = 0; y < RIADKY; y++)
    for(x = 0; x < STLPCE; x++) {
      if(poznam[y][x] == STENA && data.mapa[y][x] == VOLNO) poznam[y][x] = VOLNO, objavil = 1;
      if(data.mapa[y][x] != UNKNOWN && poznam[y][x] == UNKNOWN)
        poznam[y][x] = data.mapa[y][x], rozteky[y][x] -= ROZ_NEPRESKUMANE, objavil = 1;
    }
  if(objavil) {
    for(y = 0; y < RIADKY; y++)
      for(x = 0; x < STLPCE; x++)
        if(rozteky[y][x] == ROZ_ROZTEK) rozteky[y][x] = 0;
    // ROZ_ROZTEK nesmie byt rovnaky ako ROZ_NEPRESKUMANE
    for(y = 0; y < RIADKY; y++)
      for(x = 0; x < STLPCE; x++)
        if(poznam[y][x] == VOLNO)
          if(poznam[y-1][x] + poznam[y+1][x] + poznam[y][x-1] + poznam[y][x+1] == 2 &&
              (poznam[y-1][x] + poznam[y][x-1]) % 2 == 0 &&
              (poznam[y-1][x-1] == 0 || poznam[y+1][x-1] == 0 || poznam[y-1][x+1] == 0 || poznam[y+1][x+1] == 0))
            rozteky[y][x] = ROZ_ROZTEK;
  }
  
  if(0)
  for(y = 0; y < RIADKY; y++) {   // DUMP!
    for(x = 0; x < STLPCE; x++)
      putchar(rozteky[y][x] == ROZ_ROZTEK ? '@' : poznam[y][x] == UNKNOWN ? '?' : poznam[y][x] == VOLNO ? '.' : 'X');
    putchar('\n');
  }
  fflush(stdout);
  
  if(stopBoj)
    for(y = 0; y < RIADKY; y++)
      for(x = 0; x < STLPCE; x++)
        chcemeammo[y][x] /= 3;
  
  if(stopBoj == 0)
    if(rand()%5 == 0 || (rozteky[data.y][data.x] == ROZ_ROZTEK && rand()%3 == 0))
      chcemeammo[rand()%RIADKY][rand()%STLPCE] = 160;
  
  double najuhol = 1000;
  for(y = 0; y < data.nObjects; y++) {
    if(data.objects[y].type == OBJECT_PLAYER) {
      int oox = data.objects[y].x - data.x, ooy = data.objects[y].y - data.y;
      /*
      int smer = data.objects[y].rotate - data.rotate - 8;
      while(smer < -8) smer += 16; while(smer >= 8) smer -= 16;
      if(data.curweapon == BAZOOKA || data.curweapon == KATUSA || data.objects[y].y == data.y || data.objects[x].x == data.x || oox*oox+ooy*ooy < 80)
        if(targetRot == -1 || zAbs(smer) < targetRot) {
          targetRot = zAbs(smer); bojujeme = y;
          targx = data.objects[y].x; targy = data.objects[y].y;
        }
      */
      for(x = -4; x <= 4; x++) {
        int r = data.rotate + x; while(r < 0) r += 16; while(r >= 16) r -= 16;
        double uu = fabs(atan2(smery[r], smerx[r]) - atan2(ooy, oox));   // hmm, uzitocne...
        if(uu < najuhol) {
          najuhol = uu; ret.rotate = x;
          bojujeme = y; targx = data.objects[y].x; targy = data.objects[y].y;
        }
      }
    }
    if(data.objects[y].type >= OBJECT_AMMO) {
      if(data.objects[y].x == data.x && data.objects[y].y == data.y) continue;
      x = data.objects[y].type - OBJECT_AMMO;
      x = zbrane[x][4]*2 - data.zbytky[x];
      if(x < 3) x = 3;
      chcemeammo[data.objects[y].y][data.objects[y].x] = x*DOBRE_CHCEMEAMMO;
      if(!videl_ammo[data.objects[y].y][data.objects[y].x]) {
        dobrespomienky[data.objects[y].y][data.objects[y].x] += DOBRE_AMMO;
        videl_ammo[data.objects[y].y][data.objects[y].x] = 1;
      }
    }
  }
  
  if(chcemeammo[data.y][data.x]) chcemeammo[data.y][data.x] = 0;
  
  if(data.spawned && (mojX || mojY)) { // zabili ma
    zlespomienky[mojY][mojX] += ZLE_ZABILI_MA;   // fakt zle spomienky
    zlespomienky[mojY-1][mojX] += ZLE_ZABILI_MA * ZLE_BLUR;
    zlespomienky[mojY+1][mojX] += ZLE_ZABILI_MA * ZLE_BLUR;
    zlespomienky[mojY][mojX-1] += ZLE_ZABILI_MA * ZLE_BLUR;
    zlespomienky[mojY][mojX+1] += ZLE_ZABILI_MA * ZLE_BLUR;
    mojHP = data.hp;
    stopBoj = chcemReloadovat = 0;
  }
  
  if(data.hp < mojHP) {
    // strelili ma!
    zlespomienky[mojY][mojX] += ZLE_STRELILI_MA;   // neprijemne spomienky
    zlespomienky[mojY-1][mojX] += ZLE_STRELILI_MA * ZLE_BLUR;
    zlespomienky[mojY+1][mojX] += ZLE_STRELILI_MA * ZLE_BLUR;
    zlespomienky[mojY][mojX-1] += ZLE_STRELILI_MA * ZLE_BLUR;
    zlespomienky[mojY][mojX+1] += ZLE_STRELILI_MA * ZLE_BLUR;
    if(bojujeme == -1) strielaliMa=1;
  }
  mojHP = data.hp;
  
  ret.weaponaction = NOTHING;
  
  if(stopBoj) {
    stopBoj--;
    bojujeme = -1;
  }
  if(bojujeme != -1) {
    if(!(
        data.zasobniky[UZI]>3 || data.zbytky[UZI]>3 ||
        data.zasobniky[PISTOL]>1 || data.zbytky[PISTOL]>1 ||
        data.zasobniky[BROKOVNICA]>0 || data.zbytky[BROKOVNICA]>0 ||
        (data.curweapon == KATUSA && (data.zasobniky[KATUSA] || data.zbytky[KATUSA])) ||
        (data.curweapon == BAZOOKA && (data.zasobniky[BAZOOKA] || data.zbytky[BAZOOKA]))
        )) {
      bojujeme = -1;
      stopBoj = 7;
      printf("NEMAM AMMO! HLADAM.\n");
    }
  }
  if(bojujeme != -1) {
    do {
      y = rand()%4; ret.mx = sx[y]; ret.my = sy[y];
    } while(poznam[data.y+ret.my][data.x+ret.mx] == STENA);
    printf("[BOJ:%d][%d] ", data.curweapon, data.blocktime);
#if 0
    ret.rotate = (int)(atan2(targy-data.y, targx-data.x) * 16 / (2*M_PI)) - data.rotate;
    while(ret.rotate <= -8) ret.rotate += 16;
    while(ret.rotate > 8) ret.rotate -= 16;
#endif
    // teraz samotna bojova akcia
    if(data.blocktime == 0 && chcemReloadovat == 2)    // doreloadovali sme?
      chcemReloadovat = 0, printf("[doreloadovane] ");   // mame reloadnute
    if(data.blocktime == 0 && data.zasobnik > 0) {
      printf("[MOZEM!] ");
      ret.weaponaction = SHOT;
      if(data.curweapon == BAZOOKA || data.curweapon == KATUSA)
        for(y = 0; y < RIADKY; y++) for(x = 0; x < STLPCE; x++)
          if(data.mapa[y][x] == STENA && ((y-data.y)*(y-data.y))+((x-data.x)*(x-data.x)) < 9)
            { ret.weaponaction=NOTHING; printf("[rusim raketu] "); break; }
      if((ret.rotate > 2 || ret.rotate < -2) && data.curweapon != BROKOVNICA)
        ret.weaponaction = NOTHING, printf("[rusim:smer%d] ", ret.rotate);
      if(ret.rotate > 2) ret.rotate = 2; if(ret.rotate < -2) ret.rotate = -2;
      if(najuhol > 0.4) ret.weaponaction = NOTHING, printf("[zle pocasie] ");
      if(ret.weaponaction == SHOT) {
        dobrespomienky[mojY][mojX] += DOBRE_STRELIL;
        dobrespomienky[mojY-1][mojX] += DOBRE_STRELIL * ZLE_BLUR;
        dobrespomienky[mojY+1][mojX] += DOBRE_STRELIL * ZLE_BLUR;
        dobrespomienky[mojY][mojX-1] += DOBRE_STRELIL * ZLE_BLUR;
        dobrespomienky[mojY][mojX+1] += DOBRE_STRELIL * ZLE_BLUR;
        ret.mx = ret.my = 0;
        chcemReloadovat = 0;
        printf("STRIELAM tocim%+d zbranou %d ciel[%d,%d](%d,%d)\n", ret.rotate, data.curweapon, targx, targy, targx-data.x, targy-data.y);
        //if(zAbs(ret.rotate) == 2) ret.rotate /= 2;
      }
    }
    if(ret.weaponaction == NOTHING && chcemReloadovat == 1 && data.zbytok == 0)
      chcemReloadovat = 0, printf("[nemam co reloadovat] ");
    if(ret.weaponaction == NOTHING && chcemReloadovat) {
      printf("RELOAD\n");
      ret.weaponaction = RELOAD;
      chcemReloadovat = 2;
    }
    if(ret.weaponaction == NOTHING) {   // ak nic nejde, idem menit zbran
      // napln zoznam najlepsich (resp. pouzitelnych) zbrani
      int pocetzbrani = 5;   // kebyze niesu vsetky pouzitelne
      int chcemzbrane[5] = { PISTOL, UZI, BROKOVNICA, KATUSA, BAZOOKA };  // TODO!!!
      chcemReloadovat = 1;
      for(y = 0; y < pocetzbrani; y++)
        if(data.curweapon == chcemzbrane[y]) break;
      if(y == pocetzbrani || pocetzbrani == 1)
        ret.weaponaction = CHANGE_WEAPON+chcemzbrane[0];
      if(ret.weaponaction == NOTHING)
        for(x = (y+1) % pocetzbrani; x != y; x = (x+1) % pocetzbrani)
          if(data.zasobniky[chcemzbrane[x]])
            { ret.weaponaction = CHANGE_WEAPON+chcemzbrane[x]; break; }
      if(ret.weaponaction == NOTHING)
        for(x = (y+1) % pocetzbrani; x != y; x = (x+1) % pocetzbrani)
          if(data.zbytky[chcemzbrane[x]])
            { ret.weaponaction = CHANGE_WEAPON+chcemzbrane[x]; break; }
      if(ret.weaponaction == NOTHING)
        ret.weaponaction = CHANGE_WEAPON+chcemzbrane[0];
      if(ret.weaponaction == CHANGE_WEAPON+data.curweapon)
        ret.weaponaction = NOTHING;
      if(ret.weaponaction >= CHANGE_WEAPON)
        printf("MENIM NA %d!\n", ret.weaponaction-CHANGE_WEAPON);
    }
  }
  if(bojujeme == -1) {
    // neaktivne handlovanie zbrane
    if(data.blocktime == 0) {
      int preferweap = PISTOL;   // TODO (len mozno)
      if(data.zasobnik == 0 && data.zbytok == 0)
        ret.weaponaction = CHANGE_WEAPON+preferweap;
      else if(data.zasobnik < zbrane[data.curweapon][3] && data.zbytok > 0)
        ret.weaponaction = RELOAD;
      else {
        for(y = 0; y < NWEAPONS; y++) {
          if(data.zasobniky[y] < zbrane[y][3] && data.zbytky[y] > 0) {
            ret.weaponaction = CHANGE_WEAPON+y;
            break;
          }
        }
        if(y == NWEAPONS && data.curweapon != preferweap)
          ret.weaponaction = CHANGE_WEAPON+preferweap;
      }
    }
    
    if(data.x == dalekox && data.y == dalekoy) dalekox = -1;

    Dijkstra(data);
    int najy = data.y, najx = data.x, najvyh = -1;
    for(y = 0; y < RIADKY; y++) {
      for(x = 0; x < STLPCE; x++) {
        int vyhodnost = rozteky[y][x]*(stopBoj ? 0 : data.hp <= 40 ? 3 : 1) + dobrespomienky[y][x] + chcemeammo[y][x]*(stopBoj ? 6 : 1) - distances[y][x];
        if(dalekox == x && dalekoy == y) vyhodnost += DOBRE_ZOTRVACNOST;
        //printf("vyh [%d;%d] = %d+%d+%d-%d = %d\n", x, y, rozteky[y][x], dobrespomienky[y][x], chcemeammo[y][x], distances[y][x], vyhodnost);
        if(vyhodnost > najvyh && vyhodnost > 0) najvyh=vyhodnost,najy=y,najx=x;
      }
    }
    dalekox = najx; dalekoy = najy;
    if(najvyh == -1) {
      ret.mx = ret.my = 0;
      printf("HYB ziaden ");
    }
    else {
      printf("HYB [%d,%d]=%d ", najx, najy, najvyh); fflush(stdout);
      int novyx = najx, novyy = najy;
      while(previousx[novyy][novyx] != data.x || previousy[novyy][novyx] != data.y) {
        int tmpx = previousx[novyy][novyx]; int tmpy = previousy[novyy][novyx];
        novyx = tmpx; novyy = tmpy;
      }
      ret.mx = novyx - data.x; ret.my = novyy - data.y;
      printf("tak %d,%d->%d,%d ", data.x, data.y, novyx, novyy);
    }
    printf("(%d+%d+%d-%d) ", rozteky[najy][najx], dobrespomienky[najy][najx],
        chcemeammo[najy][najx], distances[najy][najx]);
    fflush(stdout);

    // este sa chcem otocit na dobru stranu
    int newstrana = data.rotate / 2; newstrana *= 2;
    int newrisk = GetRisk(data, newstrana);
    for(y = 0; y < 16; y += 2) {
      int risk = GetRisk(data, y);
      if(risk > newrisk) newrisk = risk, newstrana = y;
    }
    ret.rotate = newstrana - data.rotate;
    while(ret.rotate <= -8) ret.rotate += 16;
    while(ret.rotate > 8) ret.rotate -= 16;
    if(ret.rotate > 2) ret.rotate = 2;
    if(ret.rotate < -2) ret.rotate = -2;
    printf("TOC risk=%d s%d, od %d tocim %+d\n", newrisk, newstrana, data.rotate, ret.rotate);
    fflush(stdout);
  }
  if(data.wastedtime) printf("*** POZOR: WASTED TIME %d ***\n", data.wastedtime);
  
  mojX = data.x + ret.mx;
  mojY = data.y + ret.my;
  
  return ret;
}
